clear;
// CONSTANTS
FFT_SIZE=512;
Pav=2;
SNR_b=5;
Var=2/(10^(0.1*SNR_b));
EQ_SIZE=40;
EQ_SIZE_BY2=EQ_SIZE/2;
PRED_ORDER=1;

inx=1:FFT_SIZE;
omega=2*%pi*(inx-1)/FFT_SIZE;
Ch_Freq=(1+2*exp(-%i*omega)+3*exp(-%i*2*omega)+2*exp(-%i*3*omega)+exp(-%i*4*omega))/sqrt(19);
Eq_Freq=Pav*conj(Ch_Freq)./(Pav*(abs(Ch_Freq)).^2+2*Var);
Eq_Time=ifft(Eq_Freq);
Ac_Eq=fftshift(Eq_Time);
[Eq_Peak,Eq_Peak_Index]=max(abs(Ac_Eq));
Trunc_Ac_Eq=Ac_Eq(Eq_Peak_Index-EQ_SIZE_BY2+1:Eq_Peak_Index+EQ_SIZE_BY2);

subplot(221);
plot2d(real(Ac_Eq));
subplot(222);
plot2d(imag(Ac_Eq));
subplot(223);
plot2d(Eq_Freq);
subplot(224);
plot2d(Ch_Freq);

Noise_PSD=Var*Pav./(Pav*(abs(Ch_Freq)).^2+2*Var);
clf();
subplot(121);
plot2d(Noise_PSD);
Noise_AC=ifft(Noise_PSD);
Act_Noise_AC=fftshift(Noise_AC);
subplot(122);
plot2d(Act_Noise_AC);
[Peak, Peak_Index]=max(abs(Act_Noise_AC));
Trunc_AC=Act_Noise_AC(Peak_Index:Peak_Index+PRED_ORDER+1);
[la, sig]=levin(PRED_ORDER,Trunc_AC');
FB_Coeff=coeff(la(PRED_ORDER));

FF_Filter=convol(FB_Coeff,Ac_Eq);
[FF_Peak,FF_Peak_Index]=max(abs(FF_Filter));
Trunc_FF_Filter=FF_Filter(FF_Peak_Index-EQ_SIZE_BY2+2:FF_Peak_Index+EQ_SIZE_BY2+1); // Diff. from opt_eq1.sce.

Temp1(:,1)=imag(Trunc_FF_Filter)';
Temp1(:,2)=real(Trunc_FF_Filter)';
Temp2(:,1)=imag(FB_Coeff)';
Temp2(:,2)=real(FB_Coeff)';
Temp3(:,1)=imag(Trunc_Ac_Eq)';
Temp3(:,2)=real(Trunc_Ac_Eq)';

fd1=mopen('opt_cdfe_ff.dat','w');
fd2=mopen('opt_fb.dat','w');
fd3=mopen('opt_pdfe_ff.dat','w');

for inx=1:EQ_SIZE
 mfprintf(fd1,'%f %f\n',Temp1(inx,1),Temp1(inx,2));
end

for inx=2:PRED_ORDER+1
 mfprintf(fd2,'%f %f\n',Temp2(inx,1),Temp2(inx,2));
end

for inx=1:EQ_SIZE
 mfprintf(fd3,'%f %f\n',Temp3(inx,1),Temp3(inx,2));
end
