/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teq1type.h"
#include "teq1ext.h"
/******************************************************************************/
/*   Compute the final a posteriori probabilities for the channel MAP decoder.
*******************************************************************************/
int Compute_Final_APPLes_Ch()
{
 int time;
 double app[NUM_INPUTS];
 for(time=ZERO;time<CH_IV_SIZE;time++)
 {
  Get_Final_APPLe_Ch(time,app);
  Get_Final_Prob_Ch(time,app);
 }
 return(0);
}
/******************************************************************************/
/*   Get the final unnormalized probabilities for the channel MAP detector.
*******************************************************************************/
int Get_Final_APPLe_Ch(time,app)
int time;
double app[];
{
 int state,input,nxt_state;
 double prv_alpha,nxt_beta,gamma,prob;
 app[ZERO]=app[ONE]=0.0;
 for(state=ZERO;state<NUM_CH_STATES;state++)
 {
  for(input=ZERO;input<NUM_INPUTS;input++)
  {
   nxt_state=Ch_Trel_NS[state][input];
   prv_alpha=Ch_Alpha[time][state];
   nxt_beta=Ch_Beta[time+ONE][nxt_state];
   gamma=Ch_Gamma[time][state][input];
   prob=Ch_Prob[time][input];
   app[input]=app[input]+prv_alpha*nxt_beta*gamma;
  }
 }
 return(0);
}
/******************************************************************************/
/*    Get the final normalized probabilities for the channel MAP detector.
*******************************************************************************/
int Get_Final_Prob_Ch(time,app)
int time;
double app[];
{
 int input;
 double sum;
 sum=0.0;
 for(input=ZERO;input<NUM_INPUTS;input++)
  sum=sum+app[input];
 for(input=ZERO;input<NUM_INPUTS;input++)
  Ch_Prob[time][input]=app[input]/sum;
 return(0);
}
/******************************************************************************/
