/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
/******************************************************************************/
/*                    SIMULATION RUN LENGTH PARAMETERS.
*******************************************************************************/
#define MAX_FRAMES 1000                         /* Length of simulation run. */
#define FRAME_SIZE 1000                      /* No. of input bits in a frame. */
#define FRAME_SIZE_P1 (FRAME_SIZE+ONE)              /* No. of input bits + 1. */
#define IV_SIZE FRAME_SIZE                        /* Size of the interleaver. */
#define CH_IV_SIZE (2*IV_SIZE)            /* Size of the channel interleaver. */
#define CH_IV_SIZE_P1 (CH_IV_SIZE+1)      /* Size of the channel interleaver. */
/******************************************************************************/
/*                          PUNCTURING PARAMETERS.
*******************************************************************************/
#define P1_EXISTS 0                 /* Parity 1 occurs at even time instants. */
/******************************************************************************/
/*                         CONSTELLATION PARAMETERS.
*******************************************************************************/
#define BITS_PER_SYM 1                                /* Bits per tx. symbol. */
#define CONSTELL_SIZE 2                      /* Size of output constellation. */
/******************************************************************************/
/*                          TRELLIS PARAMETERS.
*******************************************************************************/
#define MEM_SIZE 2                                      /* Memory of encoder. */
#define ENC_SIZE (MEM_SIZE+1)                /* Max. no. of taps for encoder. */
#define NUM_STATES 4               /* No. of states in the component trellis. */
#define NUM_INPUTS 2                          /* No. of inputs to each state. */
/******************************************************************************/
/*                             CHANNEL PARAMETERS.
*******************************************************************************/
#define CHAN_SIZE (CHAN_MEM_SIZE+1)                        /* Channel length. */
#define CHAN_MEM_SIZE 2                                    /* Channel memory. */
#define NUM_CH_STATES 4                             /* No. of channel states. */
/******************************************************************************/
/*                  GAUSSIAN NOISE GENERATOR PARAMETERS.
*******************************************************************************/
#define SNR_B (+4.00)                                        /* SNR per bit. */
#define PN_SIZE 3                 /* Size of array which stores the PN value. */
#define NVALSIZE 4
#define URADIUS 0
#define UTHETA 1
#define GRAND_0 2
#define GRAND_1 3
/******************************************************************************/
/*                             BCJR PARAMETERS.
*******************************************************************************/
#define MAX_OUTER 2                   /* No. of iterations in the outer loop. */
#define MAX_INNER 4                   /* No. of iterations in the inner loop. */
/******************************************************************************/
/*                                PRINT TIME.
*******************************************************************************/
#define PRINT_TIME 1
#define PRINT_FRAME 250
/******************************************************************************/
/*                             CONSTANTS.
*******************************************************************************/
#define BINSIZE 16         /* Size of array to store states in binary format. */
#define TWO 2
#define ONE 1
#define ZERO 0
#define TRUE 1
#define FALSE 0
#define LEFT 0
#define RIGHT 1
#define RE 0
#define IM 1
#define MINUSONE (-1)
#define ERROR 0.00000001
#define FRAC_ZERO 0.0
#define MIN_MAG (-10.0)
#define MY_PI 3.14159265358979323846
#define PIBY2 1.57079632679489661923
#define PIBY4 0.785398163397448309615
#define TWICEPI 6.28318530717958647692
/******************************************************************************/
