/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teq10type.h"
#include "teq10ext.h"
/******************************************************************************/
/*         Compute the final APPs in the last iteration for decoder 1.
*******************************************************************************/
int Compute_Final_APPs_Dec1()
{
 int time;
 double fapp[NUM_INPUTS];
 for(time=ZERO;time<FRAME_SIZE;time++)
 {
  Get_Final_APP_Dec1(time,fapp);
  Get_Final_Prob_Dec1(time,fapp);
 }
 return(0);
}
/******************************************************************************/
/*  Get the final unnormalized probabilities for the systematic bit and parity
 *  for decoder 1.
*******************************************************************************/
int Get_Final_APP_Dec1(time,fapp)
int time;
double fapp[];
{
 int state,input,nxt_state,op;
 double gi,ge,nxt_beta,prv_alpha;
 fapp[ZERO]=fapp[ONE]=0.0;
 for(state=ZERO;state<NUM_STATES;state++)
 {
  for(input=ZERO;input<NUM_INPUTS;input++)
  {
   nxt_state=Trel_NS[state][input];
   op=Trel_Op[state][input];
   gi=Gamma_I[time][input];                       /* Corresponds to parity 0. */
   ge=Gamma_P[time][op];                          /* Corresponds to parity 1. */
   prv_alpha=Alpha[time][state];
   nxt_beta=Beta[time+ONE][nxt_state];
   fapp[input]=fapp[input]+gi*ge*prv_alpha*nxt_beta;
  }
 }
 return(0);
}
/******************************************************************************/
/*   Get the final normalized probabilities at the channel interleaver output.
*******************************************************************************/
int Get_Final_Prob_Dec1(time,fapp)
int time;
double fapp[];
{
 int input;
 double sum;
 sum=0.0;
 for(input=ZERO;input<NUM_INPUTS;input++)
  sum=sum+fapp[input];
 for(input=ZERO;input<NUM_INPUTS;input++)
  Prob[time][input]=fapp[input]/sum;
 return(0);
}
/******************************************************************************/
