/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teq10type.h"
#include "teq10ext.h"
/******************************************************************************/
/*                          Get the trellis.
*******************************************************************************/
int Get_Trellis_History()
{
 int num_ip,p_state,p_input;
 int ip_array[FB_SIZE],parity[FB_SIZE],new_st;
 num_ip=MOD_INPUTS;
 for(p_state=ZERO;p_state<NUM_STATES;p_state++)
 {
  for(p_input=ZERO;p_input<MOD_INPUTS;p_input++)
  {
   Decimal_to_Binary(p_input,ip_array,FB_SIZE);
   new_st=Fill_Mem(num_ip,p_state,p_input,FB_SIZE,ip_array,parity);
   Get_Trel_Hist(new_st,p_input,ip_array,parity);
  }
 }
 Print_Trellis_History();
 return(0);
}
/******************************************************************************/
/*                   Get the history for a given state.
*******************************************************************************/
int Get_Trel_Hist(new_st,p_input,ip_array,parity)
int new_st,p_input,ip_array[],parity[];
{
 int cnt;
 for(cnt=ZERO;cnt<FB_SIZE;cnt++)
 {
  Trel_Ip_Array[new_st][p_input][cnt]=ip_array[cnt];
  Trel_Pt_Array[new_st][p_input][cnt]=parity[cnt];
 }
 return(0);
}
/******************************************************************************/
/*                          Print the trellis history.
*******************************************************************************/
int Print_Trellis_History()
{
 int p_state,p_input,cnt;
 printf("\t Trellis history:\n\n");
 for(p_state=ZERO;p_state<NUM_STATES;p_state++)
 {
  for(p_input=ZERO;p_input<MOD_INPUTS;p_input++)
  {
   printf("\t St:%3d Ip:%d\n",p_state,p_input);
   printf("\t\t Input array:");
   for(cnt=ZERO;cnt<FB_SIZE;cnt++)
    printf("%d",Trel_Ip_Array[p_state][p_input][cnt]);
   printf("\n");
   printf("\t\t Parity array:");
   for(cnt=ZERO;cnt<FB_SIZE;cnt++)
    printf("%d",Trel_Pt_Array[p_state][p_input][cnt]);
   printf("\n");
  }
 }
 printf("\n");
 fflush(stdout);
 return(0);
}
/******************************************************************************/
