/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teq2type.h"
#include "teq2ext.h"
/******************************************************************************/
/*                   Get uniformly distributed noise.
*******************************************************************************/
int Get_Ch_Uniform_Noise(num_indices,iv_noise_val)
int num_indices;
double iv_noise_val[];
{
 int cnt;
 double erand48();
 for(cnt=ZERO;cnt<num_indices;cnt++)
  iv_noise_val[cnt]=erand48(Iv_Noise_Store);
 return(0);
}
/******************************************************************************/
/*                 Initialize the interleaver check vector.
*******************************************************************************/
int Init_Ch_Ck_Iv_Inx(ck_iv_inx)
int ck_iv_inx[];
{
 int cnt;
 for(cnt=ZERO;cnt<CH_IV_SIZE;cnt++)
  ck_iv_inx[cnt]=ZERO;
 return(0);
}
/******************************************************************************/
/*                        Get the interleaver map.
*******************************************************************************/
int Get_Ch_Iv_Elements(num_indices,iv_map,iv_noise_val,ck_iv_inx)
int num_indices,iv_map[],ck_iv_inx[];
double iv_noise_val[];
{
 int cnt,max_inx,iv_inx;
 double max;
 for(iv_inx=ZERO;iv_inx<num_indices;iv_inx++)
 {
  max=MIN_MAG;
  for(cnt=ZERO;cnt<num_indices;cnt++)
  {
   if((ck_iv_inx[cnt] == ZERO) && (iv_noise_val[cnt] > max))
   {
    max=iv_noise_val[cnt];
    max_inx=cnt;
   }
  }
  ck_iv_inx[max_inx]=ONE;                    /* Dont check max_inx next time. */
  iv_map[iv_inx]=max_inx;                                 /* Interleaver map. */
 }
 return(0);
}
/******************************************************************************/
