/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teq2type.h"
#include "teq2ext.h"
/******************************************************************************/
/*                          Get the trellis.
*******************************************************************************/
int Get_Trellis()
{
 int p_state,p_input,index[NUM_STATES];
 Init_Index(index);
 printf("\t Trellis:\n\n");
 for(p_state=ZERO;p_state<NUM_STATES;p_state++)
 {
  for(p_input=ZERO;p_input<NUM_INPUTS;p_input++)
  {
   Get_Op(p_state,p_input);
   Get_Next_State(p_state,p_input,index);
  }
 }
 Print_Trellis();
 return(0);
}
/******************************************************************************/
/*                   Initialize the indices to each state.
*******************************************************************************/
int Init_Index(index)
int index[];
{
 int cnt;
 for(cnt=ZERO;cnt<NUM_STATES;cnt++)
  index[cnt]=ZERO;
 return(0);
}
/******************************************************************************/
/*                          Get the parity bit.
*******************************************************************************/
int Get_Op(p_state,p_input)
int p_state,p_input;
{
 int bin_state[MEM_SIZE],cnt,op0,op1;
 Decimal_to_Binary(p_state,bin_state,MEM_SIZE);
 op0=Enc_P0[ZERO]*p_input;
 op1=Enc_P1[ZERO]*p_input;
 for(cnt=ZERO;cnt<MEM_SIZE;cnt++)
 {
  op0=op0^(Enc_P0[cnt+ONE]*bin_state[cnt]);
  op1=op1^(Enc_P1[cnt+ONE]*bin_state[cnt]);
 }
 Trel_Op[p_state][p_input]=TWO*op1+op0;
 return(0);
}
/******************************************************************************/
/*                           Get the next state.
*******************************************************************************/
int Get_Next_State(p_state,p_input,index)
int p_state,p_input,index[];
{
 int bin_state[MEM_SIZE],cnt,new_state,inx;
 Decimal_to_Binary(p_state,bin_state,MEM_SIZE);
 for(cnt=(MEM_SIZE-ONE);cnt>ZERO;cnt--)
  bin_state[cnt]=bin_state[cnt-ONE];
 bin_state[ZERO]=p_input;
 new_state=Binary_to_Decimal(bin_state,MEM_SIZE);
 inx=index[new_state]++;
 if(inx >= NUM_INPUTS)
  Error_Mes(1);
 Trel_NS[p_state][p_input]=new_state;
 Trel_PS[new_state][inx]=p_state;
 Trel_Ip[new_state]=p_input;
 return(0);
}
/******************************************************************************/
/*                          Print the trellis.
*******************************************************************************/
int Print_Trellis()
{
 int p_state,p_input;
 for(p_state=ZERO;p_state<NUM_STATES;p_state++)
 {
  for(p_input=ZERO;p_input<NUM_INPUTS;p_input++)
  {
   printf("\t State:%d Input:%d ",p_state,p_input);
   printf("Nxt. State:%d ",Trel_NS[p_state][p_input]);
   printf("Prv. State:%d ",Trel_PS[p_state][p_input]);
   printf("Ip. to State:%d ",Trel_Ip[p_state]);
   printf("Op:%d\n",Trel_Op[p_state][p_input]);
  }
 }
 printf("\n");
 return(0);
}
/******************************************************************************/
