/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teq2type.h"
#include "teq2ext.h"
/******************************************************************************/
int Pre_Processor()
{
 Ck_Var();
 Open_Files();
 Sim_Init();
 Get_BPSK_Map();
 Get_Channel_Iv_Map();
 Get_Enc_Taps();
 Get_Trellis();
 Get_Channel_Taps();
 Normalize_Channel_Taps();
 Get_Channel_Trellis();
 return(0);
}
/******************************************************************************/
/*                           Open files for reading.
*******************************************************************************/
int Open_Files()
{
 fp1=fopen("teq2data/chan.dat","r");
 fp2=fopen("teq2data/normchan.dat","w");
 if(fp1 == NULL)
  Error_Mes(7);
 if(fp2 == NULL)
  Error_Mes(8);
 return(0);
}
/******************************************************************************/
/*                           Get encoder 1 taps.
*******************************************************************************/
int Get_Enc_Taps()
{
 Get_Enc_P0_Taps();
 Get_Enc_P1_Taps();
 return(0);
}
/******************************************************************************/
/*       Get encoder 1 numerator taps corresponding to 1+D^2+D^3+D^4.
*******************************************************************************/
int Get_Enc_P0_Taps()
{
 Enc_P0[0]=1;
 Enc_P0[1]=0;
 Enc_P0[2]=1;
 return(0);
}
/******************************************************************************/
/*         Get encoder 1 denominator taps corresponding to 1+D+D^4.
*******************************************************************************/
int Get_Enc_P1_Taps()
{
 Enc_P1[0]=1;
 Enc_P1[1]=1;
 Enc_P1[2]=1;
 return(0);
}
/******************************************************************************/
/*                             Get the channel taps.
*******************************************************************************/
int Get_Channel_Taps()
{
 int cnt;
 double tap;
 cnt=ZERO;
 while(fscanf(fp1,"%lf",&tap) != EOF)
 {
  if(cnt == CHAN_SIZE)
   Error_Mes(5);
  Chan_Tap[cnt]=tap;
  cnt++;
 }
 if(cnt != CHAN_SIZE)
  Error_Mes(8);
 return(0);
}
/******************************************************************************/
/*                       Normalize the channel taps.
*******************************************************************************/
int Normalize_Channel_Taps()
{
 int cnt;
 double energy;
 energy=0.0;
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
  energy=energy+Chan_Tap[cnt]*Chan_Tap[cnt];
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
 {
  Chan_Tap[cnt]=Chan_Tap[cnt]/sqrt(energy);
  fprintf(fp2,"%lf %lf\n",(double)cnt,Chan_Tap[cnt]);
 }
 return(0);
}
/******************************************************************************/
