/******************************************************************************/
/*                           FILES TO BE READ.
*******************************************************************************/
extern FILE *fp1,*fp2,*fp3;                                 /* File pointers. */
/******************************************************************************/
/*         VARIABLES RELATED TO SYMBOL AND SAMPLE COUNT AT RECEIVER.
*******************************************************************************/
extern int Sym_Sync;     /* 1:Symbols at Rx. synchronized to Tx.;0:otherwise. */
extern int Samp_Cnt;               /* Sample count mod-S_PER_SYM at VA input. */
extern int Sym_Delay;                           /* Counts upto 'TRAINPERIOD'. */
extern int Sync_Buf[SYNC_SIZE];                              /* Sync. buffer. */
extern long Sym_Err;                                 /* Counts symbol errors. */
extern long Sym_Cnt;               /* Counts the number of symbols simulated. */
extern long V_Sym_Cnt;              /* Counts no. of valid symbols simulated. */
/******************************************************************************/
/*                VARIABLES RELATED TO SYMBOL ERROR COUNT.
*******************************************************************************/
extern int Err_Buf_Inx;                             /* Index to error buffer. */
extern int Err_Buf[ERR_BUF_SIZE];                     /* Storage for symbols. */
/******************************************************************************/
/*              VARIABLES RELATED TO PNS SEQUENCE GENERATOR.
*******************************************************************************/
extern int R_Bit[B_PER_SYM];             /* Array to store raw bits from PNS. */
/******************************************************************************/
/*                  VARIABLES RELATED TO THE CURRENT SYMBOL.
*******************************************************************************/
extern int Sym_Num;                                         /* Symbol number. */
extern double Re_Sym;                      /* Re. part of the current symbol. */
extern double Im_Sym;                      /* Im. part of the current symbol. */
/******************************************************************************/
/*                    VARIABLES RELATED TO CHANNEL.
*******************************************************************************/
extern int Ip_Cnt;                                    /* Interpolation count. */
extern double Re_Ch_Op;                        /* Re. part of channel output. */
extern double Im_Ch_Op;                        /* Im. part of channel output. */
extern double Re_Ch_Tap[CHAN_SIZE];                   /* Re. taps of channel. */
extern double Im_Ch_Tap[CHAN_SIZE];                   /* Im. taps of channel. */
extern double Re_Ch_Reg[CHAN_SIZE];                    /* Re. input register. */
extern double Im_Ch_Reg[CHAN_SIZE];                    /* Im. input register. */
/******************************************************************************/
/*     COMPLEX GAUSSIAN NOISE GENERATOR RELATED VARIABLES (CHANNEL NOISE).
*******************************************************************************/
double Ch_Var;                                          /* Variance of noise. */
unsigned short N1_Store[PNS_SIZE];                      /* Stores PNS status. */
unsigned short N2_Store[PNS_SIZE];                      /* Stores PNS status. */
double N_Val[NVALSIZE];                          /* Contains U & G rand. var. */
/******************************************************************************/
/*                 VARIABLES RELATED TO TRELLIS STRUCTURE.
*******************************************************************************/
extern int Rx_States;                                /* Number of Rx. states. */
extern int Rx_Mem;                       /* Memory of the pulse at Rx. input. */
extern int C_Size;                              /* Size of the constellation. */
extern int **N_State;                                /* Array of next states. */
extern double *Re_Map;                         /* Map to Re. part of symbols. */
extern double *Im_Map;                         /* Map to Im. part of symbols. */
extern double **Re_Rx_Op[S_PER_SYM];                        /* Re. o/p of Ch. */
extern double **Im_Rx_Op[S_PER_SYM];                        /* Im. o/p of Ch. */
/******************************************************************************/
/*               VARIABLES RELATED TO THE VITERBI DECODER.
*******************************************************************************/
extern int VA_Depth;                             /* Depth or delay of the VA. */
extern int Min_Wght_St;          /* State associated with the minimum metric. */
extern int Depth;                       /* Gives the current depth of the VA. */
extern int VA_Inp;                               /* Current input to a state. */
extern int VA_P_St;                                         /* Current state. */
extern int VA_N_St;                                            /* Next state. */
extern int VA_Op_Sym_Num;                    /* Symbol number released by VA. */
extern double Re_VA_Ip[S_PER_SYM];          /* Stores Re. sample at VA input. */
extern double Im_VA_Ip[S_PER_SYM];          /* Stores Im. sample at VA input. */
extern double Curr_Metric;             /* Metric due to current input sample. */
extern struct Trellis *Fst_Depth,*Lst_Depth;                    /* Templates. */
/******************************************************************************/
