/******************************************************************************/
/*                           FILES TO BE READ.
*******************************************************************************/
FILE *fp1,*fp2,*fp3;                                        /* File pointers. */
/******************************************************************************/
/*         VARIABLES RELATED TO SYMBOL AND SAMPLE COUNT AT RECEIVER.
*******************************************************************************/
int Sym_Sync;            /* 1:Symbols at Rx. synchronized to Tx.;0:otherwise. */
int Samp_Cnt;                      /* Sample count mod-S_PER_SYM at VA input. */
int Sym_Delay;                                  /* Counts upto 'TRAINPERIOD'. */
int Sync_Buf[SYNC_SIZE];                                     /* Sync. buffer. */
long Sym_Err;                                        /* Counts symbol errors. */
long Sym_Cnt;                      /* Counts the number of symbols simulated. */
long V_Sym_Cnt;                     /* Counts no. of valid symbols simulated. */
/******************************************************************************/
/*                VARIABLES RELATED TO SYMBOL ERROR COUNT.
*******************************************************************************/
int Err_Buf_Inx;                                    /* Index to error buffer. */
int Err_Buf[ERR_BUF_SIZE];                            /* Storage for symbols. */
/******************************************************************************/
/*              VARIABLES RELATED TO PNS SEQUENCE GENERATOR.
*******************************************************************************/
int R_Bit[B_PER_SYM];                    /* Array to store raw bits from PNS. */
/******************************************************************************/
/*                  VARIABLES RELATED TO THE CURRENT SYMBOL.
*******************************************************************************/
int Sym_Num;                                                /* Symbol number. */
double Re_Sym;                             /* Re. part of the current symbol. */
double Im_Sym;                             /* Im. part of the current symbol. */
/******************************************************************************/
/*                    VARIABLES RELATED TO CHANNEL.
*******************************************************************************/
int Ip_Cnt;                                           /* Interpolation count. */
double Re_Ch_Op;                               /* Re. part of channel output. */
double Im_Ch_Op;                               /* Im. part of channel output. */
double Re_Ch_Tap[CHAN_SIZE];                          /* Re. taps of channel. */
double Im_Ch_Tap[CHAN_SIZE];                          /* Im. taps of channel. */
double Re_Ch_Reg[CHAN_SIZE];                           /* Re. input register. */
double Im_Ch_Reg[CHAN_SIZE];                           /* Im. input register. */
/******************************************************************************/
/*     COMPLEX GAUSSIAN NOISE GENERATOR RELATED VARIABLES (CHANNEL NOISE).
*******************************************************************************/
double Ch_Var;                                          /* Variance of noise. */
unsigned short N1_Store[PNS_SIZE];                      /* Stores PNS status. */
unsigned short N2_Store[PNS_SIZE];                      /* Stores PNS status. */
double N_Val[NVALSIZE];                          /* Contains U & G rand. var. */
/******************************************************************************/
/*                 VARIABLES RELATED TO TRELLIS STRUCTURE.
*******************************************************************************/
int Rx_States;                                       /* Number of Rx. states. */
int Rx_Mem;                              /* Memory of the pulse at Rx. input. */
int C_Size;                                     /* Size of the constellation. */
int **N_State;                                       /* Array of next states. */
double *Re_Map;                                /* Map to Re. part of symbols. */
double *Im_Map;                                /* Map to Im. part of symbols. */
double **Re_Rx_Op[S_PER_SYM];                               /* Re. o/p of Ch. */
double **Im_Rx_Op[S_PER_SYM];                               /* Im. o/p of Ch. */
/******************************************************************************/
/*               VARIABLES RELATED TO THE VITERBI DECODER.
*******************************************************************************/
int VA_Depth;                                    /* Depth or delay of the VA. */
int Min_Wght_St;                 /* State associated with the minimum metric. */
int Depth;                              /* Gives the current depth of the VA. */
int VA_Inp;                                      /* Current input to a state. */
int VA_P_St;                                                /* Current state. */
int VA_N_St;                                                   /* Next state. */
int VA_Op_Sym_Num;                           /* Symbol number released by VA. */
double Re_VA_Ip[S_PER_SYM];                 /* Stores Re. sample at VA input. */
double Im_VA_Ip[S_PER_SYM];                 /* Stores Im. sample at VA input. */
double Curr_Metric;                    /* Metric due to current input sample. */
struct Trellis *Fst_Depth,*Lst_Depth;                           /* Templates. */
/******************************************************************************/
