/******************************************************************************/
#include "teq3type.h"
#include "teq3ext.h"
/******************************************************************************/
int Init_All()
{
 Init_Err_Buf();
 Init_Chan();
 Init_Noise_Gen();
 Init_VA();
 Init_Sim();
 return(0);
}
/******************************************************************************/
/*                     Initialize the error buffer.
*******************************************************************************/
int Init_Err_Buf()
{
 int cnt;
 for(cnt=ZERO;cnt<ERR_BUF_SIZE;cnt++)
  Err_Buf[cnt]= MINUSONE;
 Err_Buf_Inx=ZERO;
 return(0);
}
/******************************************************************************/
/*                     Initialize channel registers.
*******************************************************************************/
int Init_Chan()
{
 int cnt;
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
  Re_Ch_Reg[cnt]=Im_Ch_Reg[cnt]=0.0;
 return(0);
}
/******************************************************************************/
/*                 Initialize Re. and Im. noise generator.
*******************************************************************************/
int Init_Noise_Gen()
{
 int random(void);
 N1_Store[0]=(unsigned short)random();
 N1_Store[1]=(unsigned short)random();
 N1_Store[2]=(unsigned short)random();
 N2_Store[0]=(unsigned short)random();
 N2_Store[1]=(unsigned short)random();
 N2_Store[2]=(unsigned short)random();
 return(0);
}
/******************************************************************************/
/*                  Initialize the Viterbi Algorithm.
*******************************************************************************/
int Init_VA()
{
 Fst_Depth=Lst_Depth=NULL;
 Depth=ZERO;
 VA_Op_Sym_Num= MINUSTWO;
 return(0);
}
/******************************************************************************/
/*                  Initialize simulation variables.
*******************************************************************************/
int Init_Sim()
{
 Samp_Cnt=Sym_Delay= MINUSONE;
 Sym_Sync=FALSE;
 Sym_Err=ZERO;
 V_Sym_Cnt=ZERO;
 return(0);
}
/******************************************************************************/
