/******************************************************************************/
#include "teq3type.h"
#include "teq3ext.h"
/******************************************************************************/
/*                            Preprocessor.
*******************************************************************************/
int Preprocess()
{
 Open_Files();
 Init_All();
 Get_Channel();
 Normalize_Channel_Taps();
 Get_Trellis();
 Get_Noise_Variance();
 return(0);
}
/******************************************************************************/
/*                         Open files for reading.
*******************************************************************************/
int Open_Files()
{
 fp1=fopen("teq3data/normchan.dat","w");
 fp2=fopen("teq3data/chan.dat","r");
 fp3=fopen("teq3data/constell.dat","r");
 if(fp2==NULL)
  Error_Mes(2);
 if(fp3==NULL)
  Error_Mes(11);
 return(0);
}
/******************************************************************************/
/*         Get channel impulse response from input file 'chan.dat'.
*******************************************************************************/
int Get_Channel()
{
 int cnt;
 double imtap,retap;
 cnt=ZERO;
 printf("Channel taps:\n\n");
 while(fscanf(fp2,"%lf %lf",&imtap,&retap)!=EOF)
 {
  if(cnt==CHAN_SIZE)
   Error_Mes(5);
  Re_Ch_Tap[cnt]=retap;
  Im_Ch_Tap[cnt]=imtap;
  printf("\t Im:%+11.6f Re:%+11.6f\n",Im_Ch_Tap[cnt],Re_Ch_Tap[cnt]);
  cnt++;
 }
 if(cnt<CHAN_SIZE)
  Error_Mes(6);
 printf("\n");
 return(0);
}
/******************************************************************************/
/*                       Normalize the channel taps.
*******************************************************************************/
int Normalize_Channel_Taps()
{
 int cnt;
 double energy;
 energy=0.0;
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
  energy=energy+Re_Ch_Tap[cnt]*Re_Ch_Tap[cnt]+Im_Ch_Tap[cnt]*Im_Ch_Tap[cnt];
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
 {
  Re_Ch_Tap[cnt]=Re_Ch_Tap[cnt]/sqrt(energy);
  Im_Ch_Tap[cnt]=Im_Ch_Tap[cnt]/sqrt(energy);
  fprintf(fp1,"%lf %lf\n",(double)cnt,Im_Ch_Tap[cnt],Re_Ch_Tap[cnt]);
 }
 return(0);
}
/******************************************************************************/
/*                      Compute the noise variance.
*******************************************************************************/
int Get_Noise_Variance()
{
 int cnt;
 double ep,ec;
 ep=ec=0.0;
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
  ep=ep+Re_Ch_Tap[cnt]*Re_Ch_Tap[cnt]+Im_Ch_Tap[cnt]*Im_Ch_Tap[cnt];
 for(cnt=ZERO;cnt<C_Size;cnt++)
  ec=ec+Re_Map[cnt]*Re_Map[cnt]+Im_Map[cnt]*Im_Map[cnt];
 ec=ec/(double)(C_Size);
 if(SNR > MAX_SNR)
  Ch_Var=0.0;
 else
  Ch_Var=ep*ec/(2.0*pow(10.0,0.1*SNR));
 printf("\t Noise variance is %lf\n\n",Ch_Var);
 return(0);
}
/******************************************************************************/
