/******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
/******************************************************************************/
#define QAM16 0
#define PSK16 1
#define BPSK 2
#define CONSTELL BPSK
#define CHAN 1
#define MAX_SNR_DB 10.0
#define MIN_SNR_DB 3.5
#define STEP 0.25
#define CHAN_SIZE 3
#define ZERO 0
/******************************************************************************/
FILE *fp,*fp1;
double Var;
double Snr;
double Snr_db;
double Pe;
double Ch_Energy;
double Re_Ch_Tap[CHAN_SIZE];
double Im_Ch_Tap[CHAN_SIZE];
/******************************************************************************/
main()
{
 Open_File();
 Read_Channel();
 if((CONSTELL == BPSK) && (CHAN == 1))
  Write_BPSK_Chan1();
 return(0);
}
/******************************************************************************/
/*                         Open file for writing data.
*******************************************************************************/
int Open_File()
{
 if((CONSTELL == BPSK) && (CHAN == 1))
 {
  fp=fopen("n1data/bpskchan1th.dat","w");
  fp1=fopen("chan.dat","r");
 }
 if(fp == NULL)
  Error_Mes(23);
 if(fp1 == NULL)
  Error_Mes(2);
 return(0);
}
/******************************************************************************/
/*                    Read the channel coefficients.
*******************************************************************************/
int Read_Channel()
{
 int cnt;
 double imtap,retap;
 cnt=ZERO;
 Ch_Energy=0.0;
 printf("Channel taps:\n\n");
 while(fscanf(fp1,"%lf %lf",&imtap,&retap)!=EOF)
 {
  if(cnt==CHAN_SIZE)
   Error_Mes(5);
  Re_Ch_Tap[cnt]=retap;
  Im_Ch_Tap[cnt]=imtap;
  Ch_Energy=Ch_Energy+retap*retap+imtap*imtap;
  printf("\t Im:%+11.6f Re:%+11.6f\n",Im_Ch_Tap[cnt],Re_Ch_Tap[cnt]);
  cnt++;
 }
 if(cnt<CHAN_SIZE)
  Error_Mes(6);
 printf("\t Channel energy:%lf\n\n",Ch_Energy);
 return(0);
}
/******************************************************************************/
/*                          Write data to 16-QAM file.
*******************************************************************************/
int Write_BPSK_Chan1()
{
 Snr_db=MIN_SNR_DB;
 while(Snr_db < MAX_SNR_DB)
 {
  Var=Ch_Energy/(2.0*pow(10.0,0.1*Snr_db));
  Pe=0.5*erfc(sqrt((4.0*Ch_Energy)/(8.0*Var)));
  fprintf(fp,"%16.12lf %16.12lf\n",Snr_db,Pe);
  Snr_db=Snr_db+STEP;
 }
 return(0);
}
/******************************************************************************/
/*                             Error messages.
*******************************************************************************/
int Error_Mes(num)
int num;
{
 printf("\t Simulation error. Exiting with code %d.\n",num);
 exit(num);
}
/******************************************************************************/
