/******************************************************************************/
#include "teq3type.h"
#include "teq3ext.h"
/******************************************************************************/
/*   Shifts the contents of the register to the right to allow a new sample.
*******************************************************************************/
int Right_Shift(rereg,imreg,REGSIZE)
double rereg[],imreg[];
int REGSIZE;
{
 int cnt;
 for(cnt=(REGSIZE-1);cnt>ZERO;cnt--)
 {
  rereg[cnt]=rereg[cnt-1];
  imreg[cnt]=imreg[cnt-1];
 }
 return(0);
}
/******************************************************************************/
/*              Left the contents of the register to the left.
*******************************************************************************/
int Left_Shift(array,size)
int array[],size;
{
 int cnt;
 for(cnt=ZERO;cnt<size-ONE;cnt++)
  array[cnt]=array[cnt+ONE];
 return(0);
}
/******************************************************************************/
/* Complex convolution. One 'ip1[]' is real and the 'xxip2[]' is complex.
   Input arrays: 'ip1[ip1size]' is first array.
                 'xxip2[ip2size]' is second array.
   Output array: 'xxop[]'.
*******************************************************************************/
int Convolve(ip1,reip2,imip2,reop,imop,ip1size,ip2size)
int ip1size,ip2size;
double ip1[],reip2[],imip2[],reop[],imop[];
{
 int opcnt,ipcnt,loop;
 for(opcnt=ZERO;opcnt<(ip1size+ip2size-1);opcnt++)
 {
  reop[opcnt]=imop[opcnt]=0.0;
  ipcnt=ZERO;
  loop=TRUE;
  while((ipcnt<ip1size)&&(loop==TRUE))
  {
   if((opcnt-ipcnt)<ZERO)
    loop=FALSE;
   else if((opcnt-ipcnt)>=ip2size)
    ipcnt=opcnt-ip2size+1;
   else
   {
    reop[opcnt]=reop[opcnt]+ip1[ipcnt]*reip2[opcnt-ipcnt];
    imop[opcnt]=imop[opcnt]+ip1[ipcnt]*imip2[opcnt-ipcnt];
    ipcnt++;
   }
  }
 }
 return(0);
}
/******************************************************************************/
/*       Convert uniform random variables to gaussian random variables.
*******************************************************************************/
int My_Gauss(tvar,tnarry)
double tvar,tnarry[];
{
 double r,theta;
 r= -2.0*tvar*log(1.0-tnarry[URADIUS]);
 if(r<0.0)
 {
  printf("r:%lf URADIUS:%lf\n",r,tnarry[URADIUS]);
  r=0.0;
 }
 r=pow(r,0.5);
 theta=2.0*PI*tnarry[UTHETA];
 tnarry[GRAND_0]=r*cos(theta);
 tnarry[GRAND_1]=r*sin(theta);
 return(0);
}
/******************************************************************************/
/*                             Error messages.
*******************************************************************************/
int Error_Mes(num)
int num;
{
 printf("\t Simulation error. Exiting with code %d.\n",num);
 exit(num);
}
/******************************************************************************/
