/******************************************************************************/
#include "teq3type.h"
#include "teq3ext.h"
/******************************************************************************/
/*                            Postprocessor.
*******************************************************************************/
int Viterbi()
{
 if(Depth<(VA_Depth-ONE))
  Pre_VA_Depth();
 else if(Depth==(VA_Depth-ONE))
 {
  VA_Link_Alloc();
  VA_Sub_Alloc();
  Metric_Reinit();
 }
 if(Depth==VA_Depth)
  Post_VA_Depth();
 return(0);
}
/******************************************************************************/
/*              Procedures for depth less than 'VA_Depth-1'.
*******************************************************************************/
int Pre_VA_Depth()
{
 VA_Link_Alloc();
 VA_Sub_Alloc();
 Metric_Reinit();
 Calculate_Metric();
 /*Print_Metrics();*/
 return(0);
}
/******************************************************************************/
/* Do memory allocation for a link. The 'Fst_Depth' corresponds to the
   first incoming symbol in time and the 'Lst_Depth' corresponds to the 
   last incoming symbol in time.
*******************************************************************************/
int VA_Link_Alloc()
{
 void *tmp;
 void *malloc();
 struct Trellis *curr;
 tmp=malloc(sizeof(struct Trellis));
 Ck_Calloc(tmp);
 curr=(struct Trellis *)tmp;
 if(Depth==ZERO)
  Fst_Depth=curr;
 curr->Prv_Depth=Lst_Depth;
 curr->Nxt_Depth=NULL;
 if(Lst_Depth!=NULL)
  Lst_Depth->Nxt_Depth=curr;
 Lst_Depth=curr;                            /* This completes double linking. */
 return(0);
}
/******************************************************************************/
/*          Do memory allocations for arrays within a structure.
*******************************************************************************/
int VA_Sub_Alloc()
{
 void *tmp;
 void *calloc();
 tmp=calloc(Rx_States,sizeof(int));           /* For storing previous states. */
 Ck_Calloc(tmp);
 Lst_Depth->St_Path=(int *)tmp;
 tmp=calloc(Rx_States,sizeof(int));      /* For storing corresponding inputs. */
 Ck_Calloc(tmp);
 Lst_Depth->Ip_Path=(int *)tmp;
 tmp=calloc(Rx_States,sizeof(double));        /* For storing current metrics. */
 Ck_Calloc(tmp);
 Lst_Depth->VA_Wght=(double *)tmp;
 Depth++;
 return(0);
}
/******************************************************************************/
/*                       Processing at 'VA_Depth'.
*******************************************************************************/
int Post_VA_Depth()
{
 Calculate_Metric();
 Get_Min_Metric();
 /*Print_Metrics();*/
 Get_Last_Symbol();
// Normalize_Metrics();
 Linked_List_Reinit();
 Metric_Reinit();
 return(0);
}
/******************************************************************************/
