/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
extern FILE *fp1,*fp2;                                      /* File pointers. */
/******************************************************************************/
/*                                BIT VARIABLES.
*******************************************************************************/
extern int Bits[FRAME_SIZE];                             /* Information bits. */
extern int Frame_Cnt;                                         /* Frame count. */
extern int Ber;                                            /* Bit error rate. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
extern int Enc_State;                                       /* Encoder state. */
extern int Enc_Op[CH_IV_SIZE];                                /* Encoder o/p. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
extern double Bit_Map[CONSTELL_SIZE];                /* Map to constellation. */
/******************************************************************************/
/*                    VARIABLES RELATED TO INTERLEAVER.
*******************************************************************************/
extern int Iv_Map[IV_SIZE];                           /* Interleaver mapping. */
extern int De_Iv_Map[IV_SIZE];                      /* Deinterleaver mapping. */
extern unsigned short Iv_Noise_Store[PN_SIZE];          /* Stores PNS status. */
/******************************************************************************/
/*                 VARIABLES RELATED TO CHANNEL INTERLEAVER.
*******************************************************************************/
extern int Ch_Iv_Map[CH_IV_SIZE];                     /* Interleaver mapping. */
extern int Ch_De_Iv_Map[CH_IV_SIZE];                /* Deinterleaver mapping. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
extern unsigned short N1_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N2_Store[PN_SIZE];                /* Stores PNS status. */
extern double Variance;                                    /* Noise variance. */
extern double Inv_Twice_Noise_Var;    /* Inverse of twice the noise variance. */
extern double N1_Val[NVALSIZE];                  /* Contains U & G rand. var. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
extern int Enc_N[ENC_SIZE];                    /* Stores encoder numer. taps. */
extern int Enc_D[ENC_SIZE];                    /* Stores encoder denom. taps. */
extern int Trel_NS[NUM_STATES][NUM_INPUTS];                    /* Next state. */
extern int Trel_PS[NUM_STATES][NUM_INPUTS];                    /* Prev state. */
extern int Trel_Ip[NUM_STATES];                    /* Stores input to states. */
extern int Trel_Op[NUM_STATES][NUM_INPUTS];                       /* Outputs. */
/******************************************************************************/
/*                VARIABLES RELATED TO THE CHANNEL TRELLIS.
*******************************************************************************/
extern int Ch_Trel_NS[NUM_CH_STATES][NUM_INPUTS];              /* Next state. */
extern int Ch_Trel_PS[NUM_CH_STATES][NUM_INPUTS];              /* Prev state. */
extern int Ch_Trel_Ip[NUM_CH_STATES];                      /* Input to state. */
extern double Ch_Trel_Op[NUM_CH_STATES][NUM_INPUTS];              /* Outputs. */
/******************************************************************************/
/*                     VARIABLES RELATED TO THE CHANNEL.
*******************************************************************************/
extern int Chan_F_State;                       /* Final state of the channel. */
extern double Chan_Tap[CHAN_SIZE];                   /* Channel coefficients. */
extern double Chan_Op[CH_IV_SIZE];                         /* Channel output. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
extern int Inner_Cnt;                                  /* Inner loop counter. */
extern double Alpha[FRAME_SIZE][NUM_STATES];                       /* Alphas. */
extern double Beta[FRAME_SIZE_P1][NUM_STATES];                      /* Betas. */
extern double Gamma_I[FRAME_SIZE][NUM_INPUTS];       /* Intrinsic info: data. */
extern double Gamma_P[FRAME_SIZE][NUM_INPUTS];     /* Extrinsic info: parity. */
extern double Prob[FRAME_SIZE][NUM_INPUTS];            /* Data probabilities. */
/******************************************************************************/
/*                BCJR VARIABLES RELATED TO CHANNEL DECODER.
*******************************************************************************/
extern int Outer_Cnt;                                  /* Outer loop counter. */
extern double Ch_Alpha[CH_IV_SIZE][NUM_CH_STATES];                  /* Alpha. */
extern double Ch_Beta[CH_IV_SIZE_P1][NUM_CH_STATES];                 /* Beta. */
extern double Ch_Gamma[CH_IV_SIZE][NUM_CH_STATES][NUM_INPUTS];      /* Gamma. */
extern double Ch_Prob[CH_IV_SIZE][NUM_INPUTS];              /* Probabilities. */
/******************************************************************************/
