/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teq5type.h"
#include "teq5ext.h"
/******************************************************************************/
/*                          Get the trellis.
*******************************************************************************/
int Get_Channel_Trellis()
{
 int p_state,p_input,index[NUM_CH_STATES];
 Init_Index(index);
 printf("\t Channel trellis:\n\n");
 for(p_state=ZERO;p_state<NUM_CH_STATES;p_state++)
 {
  for(p_input=ZERO;p_input<NUM_CH_INPUTS;p_input++)
  {
   Get_Ch_Op(p_state,p_input);
   Get_Ch_Next_State(p_state,p_input,index);
  }
 }
 Print_Ch_Trellis();
 return(0);
}
/******************************************************************************/
/*                   Initialize the indices to each state.
*******************************************************************************/
int Init_Index(index)
int index[];
{
 int cnt;
 for(cnt=ZERO;cnt<NUM_CH_STATES;cnt++)
  index[cnt]=ZERO;
 return(0);
}
/******************************************************************************/
/*                          Get the parity bit.
*******************************************************************************/
int Get_Ch_Op(p_state,p_input)
int p_state,p_input;
{
 int m_state[CHAN_MEM_SIZE],cnt,sym;
 double reop,imop;
 Decimal_To_M_ary(p_state,m_state,CHAN_MEM_SIZE,NUM_CH_INPUTS);
// sym=Precode(p_input,m_state);
 sym=p_input;
 reop=Chan_Tap[ZERO]*Bit_Map[sym%TWO];
 imop=Chan_Tap[ZERO]*Bit_Map[sym/TWO];
 for(cnt=ZERO;cnt<CHAN_MEM_SIZE;cnt++)
 {
  sym=m_state[cnt];
  reop=reop+Chan_Tap[cnt+ONE]*Bit_Map[sym%TWO];
  imop=imop+Chan_Tap[cnt+ONE]*Bit_Map[sym/TWO];
 }
 Re_Ch_Trel_Op[p_state][p_input]=reop;
 Im_Ch_Trel_Op[p_state][p_input]=imop;
 return(0);
}
/******************************************************************************/
/*                           Get the next state.
*******************************************************************************/
int Get_Ch_Next_State(p_state,p_input,index)
int p_state,p_input,index[];
{
 int m_state[CHAN_MEM_SIZE],cnt,sym,new_state,inx;
 Decimal_To_M_ary(p_state,m_state,CHAN_MEM_SIZE,NUM_CH_INPUTS);
// sym=Precode(p_input,m_state);
 sym=p_input;
 for(cnt=(CHAN_MEM_SIZE-ONE);cnt>ZERO;cnt--)
  m_state[cnt]=m_state[cnt-ONE];
 m_state[ZERO]=sym;
 new_state=Mary_to_Decimal(m_state,CHAN_MEM_SIZE,NUM_CH_INPUTS);
 inx=index[new_state]++;
 if(inx >= NUM_CH_INPUTS)
  Error_Mes(1);
 Ch_Trel_NS[p_state][p_input]=new_state;
 Ch_Trel_PS[new_state][inx]=p_state;
 Ch_Trel_Ip[new_state]=p_input;
 return(0);
}
/******************************************************************************/
/*                          Precode the input.
*******************************************************************************/
int Precode(p_input,m_state)
int p_input,m_state[];
{
 int bit0,bit1,ip0,ip1,sym;
 bit0=m_state[ZERO]%TWO;
 bit1=m_state[ZERO]/TWO;
 ip0=p_input%TWO;
 ip1=p_input/TWO;
 bit0=bit0^ip0;
 bit1=bit1^ip1;
 sym=bit0+TWO*bit1;
 return(sym);
}
/******************************************************************************/
/*                          Print the channel trellis.
*******************************************************************************/
int Print_Ch_Trellis()
{
 int p_state,p_input;
 for(p_state=ZERO;p_state<NUM_CH_STATES;p_state++)
 {
  for(p_input=ZERO;p_input<NUM_CH_INPUTS;p_input++)
  {
   printf("\t St:%d Ip:%d ",p_state,p_input);
   printf("N. St:%d ",Ch_Trel_NS[p_state][p_input]);
   printf("Prv. St:%d ",Ch_Trel_PS[p_state][p_input]);
   printf("Ip. to st:%d\n",Ch_Trel_Ip[p_state]);
   printf("\t\t Re. Op:%+lf ",Re_Ch_Trel_Op[p_state][p_input]);
   printf("Im. Op:%+lf\n",Im_Ch_Trel_Op[p_state][p_input]);
  }
 }
 printf("\n");
 return(0);
}
/******************************************************************************/
