/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teq5type.h"
#include "teq5ext.h"
/******************************************************************************/
/*   Compute the final a posteriori probabilities for the channel MAP decoder.
*******************************************************************************/
int Compute_Final_APPLes_Ch()
{
 int time;
 double reapp[NUM_INPUTS],imapp[NUM_INPUTS];
 for(time=ZERO;time<CH_IV_SIZE;time++)
 {
  Get_Final_APPLe_Ch(time,reapp,imapp);
  Get_Final_Prob_Ch(time,reapp,imapp);
 }
 return(0);
}
/******************************************************************************/
/*   Get the final unnormalized probabilities for the channel MAP detector.
*******************************************************************************/
int Get_Final_APPLe_Ch(time,reapp,imapp)
int time;
double reapp[],imapp[];
{
 int state,input,nxt_state;
 double prv_alpha,nxt_beta,gre,gim,prob;
 reapp[ZERO]=reapp[ONE]=imapp[ZERO]=imapp[ONE]=0.0;
 for(state=ZERO;state<NUM_CH_STATES;state++)
 {
  for(input=ZERO;input<NUM_CH_INPUTS;input++)
  {
   nxt_state=Ch_Trel_NS[state][input];
   prv_alpha=Ch_Alpha[time][state];
   nxt_beta=Ch_Beta[time+ONE][nxt_state];
   gre=Re_Ch_Gamma[time][state][input];
   gim=Im_Ch_Gamma[time][state][input];
   prob=Ch_Prob[time][input];
   reapp[input%TWO]=reapp[input%TWO]+prv_alpha*nxt_beta*gre*gim;
   imapp[input/TWO]=imapp[input/TWO]+prv_alpha*nxt_beta*gre*gim;
  }
 }
 return(0);
}
/******************************************************************************/
/*    Get the final normalized probabilities for the channel MAP detector.
*******************************************************************************/
int Get_Final_Prob_Ch(time,reapp,imapp)
int time;
double reapp[],imapp[];
{
 int input;
 double resum,imsum;
 resum=imsum=0.0;
 for(input=ZERO;input<NUM_INPUTS;input++)
 {
  resum=resum+reapp[input];
  imsum=imsum+imapp[input];
 }
 for(input=ZERO;input<NUM_INPUTS;input++)
 {
  Ch_Prob[TWO*time][input]=reapp[input]/resum;
  Ch_Prob[TWO*time+ONE][input]=imapp[input]/imsum;
 }
 return(0);
}
/******************************************************************************/
