/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
FILE *fp1,*fp2;                                             /* File pointers. */
/******************************************************************************/
/*                                BIT VARIABLES.
*******************************************************************************/
int Bits[FRAME_SIZE];                                    /* Information bits. */
int Frame_Cnt;                                                /* Frame count. */
int Ber;                                                   /* Bit error rate. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
int Enc_State;                                              /* Encoder state. */
int Enc_Op[CH_IV_SIZE];                                       /* Encoder o/p. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
double Bit_Map[CONSTELL_SIZE];                       /* Map to constellation. */
/******************************************************************************/
/*                 VARIABLES RELATED TO CHANNEL INTERLEAVER.
*******************************************************************************/
int Ch_Iv_Map[CH_IV_SIZE];                            /* Interleaver mapping. */
int Ch_De_Iv_Map[CH_IV_SIZE];                       /* Deinterleaver mapping. */
int Sp_Fac[CH_IV_SIZE];                                     /* Spread factor. */
unsigned short Iv_Noise_Store[PN_SIZE];                 /* Stores PNS status. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
unsigned short N1_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N2_Store[PN_SIZE];                       /* Stores PNS status. */
double Variance;                                           /* Noise variance. */
double Inv_Twice_Noise_Var;           /* Inverse of twice the noise variance. */
double N1_Val[NVALSIZE];                         /* Contains U & G rand. var. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
int Enc_N[ENC_SIZE];                           /* Stores encoder numer. taps. */
int Enc_D[ENC_SIZE];                           /* Stores encoder denom. taps. */
int Trel_NS[NUM_STATES][NUM_INPUTS];                           /* Next state. */
int Trel_PS[NUM_STATES][NUM_INPUTS];                           /* Prev state. */
int Trel_Op[NUM_STATES][NUM_INPUTS];                              /* Outputs. */
/******************************************************************************/
/*                VARIABLES RELATED TO THE CHANNEL TRELLIS.
*******************************************************************************/
int Ch_Trel_NS[NUM_CH_STATES][NUM_INPUTS];                     /* Next state. */
int Ch_Trel_PS[NUM_CH_STATES][NUM_INPUTS];                     /* Prev state. */
int Ch_Trel_Ip[NUM_CH_STATES][NUM_INPUTS];                 /* Input to state. */
double Re_Ch_Trel_Op[NUM_CH_STATES][NUM_INPUTS];                  /* Re. o/p. */
double Im_Ch_Trel_Op[NUM_CH_STATES][NUM_INPUTS];                  /* Im. o/p. */
/******************************************************************************/
/*                     VARIABLES RELATED TO THE CHANNEL.
*******************************************************************************/
int Chan_F_State;                              /* Final state of the channel. */
double Chan_Tap[CHAN_SIZE];                          /* Channel coefficients. */
double Re_Chan_Op[CH_IV_SIZE];                         /* Re. channel output. */
double Im_Chan_Op[CH_IV_SIZE];                         /* Im. channel output. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
int Inner_Cnt;                                         /* Inner loop counter. */
double Alpha[FRAME_SIZE][NUM_STATES];                              /* Alphas. */
double Beta[FRAME_SIZE_P1][NUM_STATES];                             /* Betas. */
double Gamma_I[FRAME_SIZE][NUM_INPUTS];              /* Intrinsic info: data. */
double Gamma_P[FRAME_SIZE][NUM_INPUTS];            /* Extrinsic info: parity. */
double Prob[FRAME_SIZE][NUM_INPUTS];                   /* Data probabilities. */
/******************************************************************************/
/*                BCJR VARIABLES RELATED TO CHANNEL DECODER.
*******************************************************************************/
int Outer_Cnt;                                         /* Outer loop counter. */
double Ch_Alpha[CH_IV_SIZE][NUM_CH_STATES];                         /* Alpha. */
double Ch_Beta[CH_IV_SIZE_P1][NUM_CH_STATES];                        /* Beta. */
double Re_Ch_Gamma[CH_IV_SIZE][NUM_CH_STATES][NUM_INPUTS];          /* Gamma. */
double Im_Ch_Gamma[CH_IV_SIZE][NUM_CH_STATES][NUM_INPUTS];          /* Gamma. */
double Ch_Prob[CH_IV_SIZE][NUM_INPUTS];                     /* Probabilities. */
/******************************************************************************/
