/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
extern FILE *fp1,*fp2,*fp3,*fp4;                            /* File pointers. */
/******************************************************************************/
/*                                BIT VARIABLES.
*******************************************************************************/
extern int Frame_Cnt;                                         /* Frame count. */
extern int Ber;                                            /* Bit error rate. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
extern int Enc_State;                              /* State of outer encoder. */
extern int Enc1_State;                             /* State of inner encoder. */
extern int Enc_Op[CH_IV_SIZE];                                /* Encoder o/p. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
extern double Bit_Map[CONSTELL_SIZE];                /* Map to constellation. */
/******************************************************************************/
/*                 VARIABLES RELATED TO CHANNEL INTERLEAVER.
*******************************************************************************/
extern int Ch_Iv_Map[CH_IV_SIZE];                     /* Interleaver mapping. */
extern int Ch_De_Iv_Map[CH_IV_SIZE];                /* Deinterleaver mapping. */
extern unsigned short Iv_Noise_Store[PN_SIZE];          /* Stores PNS status. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
extern unsigned short N1_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N2_Store[PN_SIZE];                /* Stores PNS status. */
extern double Variance;                                    /* Noise variance. */
extern double Inv_Twice_Noise_Var;    /* Inverse of twice the noise variance. */
extern double N1_Val[NVALSIZE];                  /* Contains U & G rand. var. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
extern int Enc_N[ENC_SIZE];                    /* Stores encoder numer. taps. */
extern int Enc_D[ENC_SIZE];                    /* Stores encoder denom. taps. */
extern int Trel_NS[NUM_STATES][NUM_INPUTS];                    /* Next state. */
extern int Trel_PS[NUM_STATES][NUM_INPUTS];                    /* Prev state. */
extern int Trel_Op[NUM_STATES][NUM_INPUTS];                       /* Outputs. */
/******************************************************************************/
/*                  VARIABLES RELATED TO THE SUPER TRELLIS.
*******************************************************************************/
extern int STrel_NS[NUM_ST_STATES][NUM_INPUTS];   /* Super trellis nxt state. */
extern int STrel_PS[NUM_ST_STATES][NUM_INPUTS];   /* Super trellis prv state. */
extern int STrel_Ip[NUM_ST_STATES][NUM_INPUTS];  /* Inputs leading to states. */
extern int STrel_Ip_Array[NUM_ST_STATES][NUM_INPUTS][PRED_SIZE];       /* Ip. */
extern int STrel_Pt_Array[NUM_ST_STATES][NUM_INPUTS][PRED_SIZE];       /* Pt. */
/******************************************************************************/
/*                     VARIABLES RELATED TO THE CHANNEL.
*******************************************************************************/
extern double Re_Ch[CHAN_SIZE];                  /* Re. channel coefficients. */
extern double Im_Ch[CHAN_SIZE];                  /* Im. channel coefficients. */
extern double Re_Ch_Reg[CHAN_SIZE];              /* Re. channel coefficients. */
extern double Im_Ch_Reg[CHAN_SIZE];              /* Im. channel coefficients. */
extern double Re_Ch_Op;                                /* Re. channel output. */
extern double Im_Ch_Op;                                /* Im. channel output. */
/******************************************************************************/
/*                            EQUALIZER VARIABLES.
*******************************************************************************/
extern int Eq_Buf_Inx;                       /* Equalizer error buffer index. */
extern int Eq_Buf[EQ_BUF_SIZE];                    /* Equalizer error buffer. */
extern double Ip_Pow;                 /* Instantaneous equalizer input power. */
extern double Step;                                             /* Step size. */
extern double Re_Grad;                               /* Re. part of gradient. */
extern double Im_Grad;                               /* Im. part of gradient. */
extern double Re_Eq_Op;                                 /* Re. equalizer o/p. */
extern double Im_Eq_Op;                                 /* Im. equalizer o/p. */
extern double Re_Eq_Err;                              /* Re. equalizer error. */
extern double Im_Eq_Err;                              /* Im. equalizer error. */
extern double Re_Eq[EQ_SIZE];                         /* Re. equalizer coeff. */
extern double Im_Eq[EQ_SIZE];                         /* Im. equalizer coeff. */
extern double Re_Eq_Reg[EQ_SIZE];                       /* Re. equalizer mem. */
extern double Im_Eq_Reg[EQ_SIZE];                       /* Im. equalizer mem. */
/******************************************************************************/
/*             VARIABLES RELATED TO PREDICTION FILTER ESTIMATION.
*******************************************************************************/
extern int Err_Reg_Inx;                           /* Index to error register. */
extern double Pred_Var;                   /* Final prediction error variance. */
extern double Inv_Twice_Pred_Var;        /* Inv. of twice the pred. err. var. */
extern double Re_Err_Reg[DATA_SIZE];                /* Re. eq. error samples. */
extern double Im_Err_Reg[DATA_SIZE];                /* Im. eq. error samples. */
extern double Re_Pred_Coeff[NUM_PRED][PRED_SIZE];         /* Re. pred. coeff. */
extern double Im_Pred_Coeff[NUM_PRED][PRED_SIZE];         /* Im. pred. coeff. */
extern double Re_AC[PRED_SIZE];                              /* Re. autocorr. */
extern double Im_AC[PRED_SIZE];                              /* Im. autocorr. */
/******************************************************************************/
/*                            RECEIVED SYMBOLS.
*******************************************************************************/
extern double Rx_Re_Sym[RX_SIZE];                             /* Rx. re. sym. */
extern double Rx_Im_Sym[RX_SIZE];                             /* Rx. im. sym. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
extern double Alpha[FRAME_SIZE][NUM_STATES];                       /* Alphas. */
extern double Beta[FRAME_SIZE_P1][NUM_STATES];                      /* Betas. */
extern double Gamma_I[FRAME_SIZE][NUM_INPUTS];       /* Intrinsic info: data. */
extern double Gamma_P[FRAME_SIZE][NUM_INPUTS];     /* Extrinsic info: parity. */
extern double Prob[FRAME_SIZE][NUM_INPUTS];            /* Data probabilities. */
/******************************************************************************/
/*                BCJR VARIABLES RELATED TO CHANNEL DECODER.
*******************************************************************************/
extern int Outer_Cnt;                                  /* Outer loop counter. */
extern double Ch_Alpha[CH_IV_SIZE][NUM_ST_STATES];                  /* Alpha. */
extern double Ch_Beta[CH_IV_SIZE_P1][NUM_ST_STATES];                 /* Beta. */
extern double Ch_Gamma[CH_IV_SIZE][NUM_ST_STATES][NUM_INPUTS];      /* Gamma. */
extern double Ch_Prob[CH_IV_SIZE][NUM_INPUTS];              /* Probabilities. */
/******************************************************************************/
