/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teq7type.h"
#include "teq7ext.h"
/******************************************************************************/
/*                   Initialize simulation variables.
*******************************************************************************/
int Sim_Init()
{
 Noise_Gen_Init();
 Get_Noise_Variance();
 Iv_Noise_Gen_Init();
 Ber_Init();
 Eq_Init();
 Chan_Init();
 return(0);
}
/******************************************************************************/
/*                     Initialize the noise generator.
*******************************************************************************/
int Noise_Gen_Init()
{
 int cnt;
 long int random(void);
 for(cnt=ZERO;cnt<PN_SIZE;cnt++)
 {
  N1_Store[cnt]=(unsigned short)random();
  N2_Store[cnt]=(unsigned short)random();
 }
 return(0);
}
/******************************************************************************/
/*                        Get the noise variance.
*******************************************************************************/
int Get_Noise_Variance()
{
 Variance=2.0/pow(10.0,0.1*SNR_B);
 printf("\t Noise variance:%lf.\n\n",Variance);
 Inv_Twice_Noise_Var=1.0/(2.0*Variance);
 if(SNR_B > MAX_SNR)
 {
  Variance=0.0;
 Inv_Twice_Noise_Var=1.0;
 }
 return(0);
}
/******************************************************************************/
/*                Initialize the interleaver noise generator.
*******************************************************************************/
int Iv_Noise_Gen_Init()
{
 int cnt;
 long int random(void);
 for(cnt=ZERO;cnt<PN_SIZE;cnt++)
  Iv_Noise_Store[cnt]=(unsigned short)random();
 return(0);
}
/******************************************************************************/
/*                       Initialize the bit error rate.
*******************************************************************************/
int Ber_Init()
{
 Ber=ZERO;
 return(0);
}
/******************************************************************************/
/*                    Initialize equalizer parameters.
*******************************************************************************/
int Eq_Init()
{
 int cnt;
 for(cnt=ZERO;cnt<EQ_SIZE;cnt++)
  Re_Eq[cnt]=Im_Eq[cnt]=Re_Eq_Reg[cnt]=Im_Eq_Reg[cnt]=0.0;
 Step=0.5;
 Err_Reg_Inx=Eq_Buf_Inx=ZERO;
 return(0);
}
/******************************************************************************/
/*                          Initialize the channel.
*******************************************************************************/
int Chan_Init()
{
 int cnt;
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
  Re_Ch_Reg[cnt]=Im_Ch_Reg[cnt]=0.0;
 return(0);
}
/******************************************************************************/
