/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teq8type.h"
#include "teq8ext.h"
/******************************************************************************/
/*                          Check the variables.
*******************************************************************************/
int Ck_Var()
{
 Ck_Tx_Constell_Size();
 Ck_Num_States();
 Ck_Num_S_States();
 Ck_Data_Size();
 return(0);
}
/******************************************************************************/
/*                Check the transmitted constellation size.
*******************************************************************************/
int Ck_Tx_Constell_Size()
{
 int cnt,pow;
 pow=1;
 for(cnt=ZERO;cnt<BITS_PER_SYM;cnt++)
  pow=pow*2;
 if(CONSTELL_SIZE != pow)
  Error_Mes(2);
 return(0);
}
/******************************************************************************/
/*                       Check the number of states.
*******************************************************************************/
int Ck_Num_States()
{
 int cnt,pow;
 pow=1;
 for(cnt=ZERO;cnt<MEM_SIZE;cnt++)
  pow=pow*2;
 if(NUM_STATES != pow)
  Error_Mes(3);
 return(0);
}
/******************************************************************************/
/*                  Check the number of super trellis states.
*******************************************************************************/
int Ck_Num_S_States()
{
 int cnt,pow;
 pow=1;
 for(cnt=ZERO;cnt<FB_SIZE;cnt++)
  pow=pow*NUM_INPUTS;
 if(pow != MOD_ST_NUM_INPUTS)
  Error_Mes(10);
 pow=pow*NUM_STATES;
 if(NUM_ST_STATES != pow)
  Error_Mes(11);
 return(0);
}
/******************************************************************************/
/*                           Check the data size.
*******************************************************************************/
int Ck_Data_Size()
{
 if(DATA_SIZE > CH_IV_SIZE)
  Error_Mes(16);
 return(0);
}
/******************************************************************************/
