/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teq9type.h"
#include "teq9ext.h"
/******************************************************************************/
int Eq_Training()
{
 Get_Eq_Err();
 if(Frame_Cnt < (TRN_FRAMES-ONE))
  Update_Eq();
 if(Frame_Cnt==(TRN_FRAMES-ONE))
  Collect_Data();
 return(0);
}
/******************************************************************************/
/*                         Get equalizer error.
*******************************************************************************/
int Get_Eq_Err()
{
 int bit,pty,cnt;
 double err_sq;
 bit=Eq_Buf[ZERO]%TWO;
 pty=Eq_Buf[ZERO]/TWO;
 for(cnt=ZERO;cnt<Eq_Buf_Inx-ONE;cnt++)
  Eq_Buf[cnt]=Eq_Buf[cnt+ONE];
 Eq_Buf_Inx--;
 if(Eq_Buf_Inx < ZERO)
  Error_Mes(12);
 Re_Eq_Err=Bit_Map[bit]-Re_Eq_Op;
 Im_Eq_Err=Bit_Map[pty]-Im_Eq_Op;
 err_sq=Re_Eq_Err*Re_Eq_Err+Im_Eq_Err*Im_Eq_Err;
 if(Frame_Cnt == (TRN_FRAMES-ONE))
  fprintf(fp3,"%lf\n",err_sq);
 return(0);
}
/******************************************************************************/
/*                Update the equalizer coefficients.
*******************************************************************************/
int Update_Eq()
{
 int cnt;
 Ip_Pow=0.0;
 for(cnt=ZERO;cnt<EQ_SIZE;cnt++)
  Ip_Pow=Ip_Pow+Re_Eq_Reg[cnt]*Re_Eq_Reg[cnt]+Im_Eq_Reg[cnt]*Im_Eq_Reg[cnt];
 for(cnt=ZERO;cnt<EQ_SIZE;cnt++)
 {
  Re_Grad=Re_Eq_Err*Re_Eq_Reg[cnt]+Im_Eq_Err*Im_Eq_Reg[cnt];
  Im_Grad=Im_Eq_Err*Re_Eq_Reg[cnt]-Re_Eq_Err*Im_Eq_Reg[cnt];
  Re_Eq[cnt]=Re_Eq[cnt]+Step*Re_Grad/Ip_Pow;
  Im_Eq[cnt]=Im_Eq[cnt]+Step*Im_Grad/Ip_Pow;
 }
 return(0);
}
/******************************************************************************/
/*         Collect the data for updating the predictor coefficients.
*******************************************************************************/
int Collect_Data()
{
 if(Err_Reg_Inx < DATA_SIZE)
 {
  Re_Err_Reg[Err_Reg_Inx]=Re_Eq_Err;
  Im_Err_Reg[Err_Reg_Inx]=Im_Eq_Err;
  Err_Reg_Inx++;
 }
 if(Err_Reg_Inx == DATA_SIZE)
 {
  Initialize_Predictor();
  Err_Reg_Inx++;
 }
 return(0);
}
/******************************************************************************/
