/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teq9type.h"
#include "teq9ext.h"
/******************************************************************************/
int Initialize_Predictor()
{
 Get_Autocorr();
 Inv_Twice_Eq_Err_Var=1.0/(2.0*Eq_Err_Var);
 printf("\t Eq. error variance:%lf\n",Eq_Err_Var);
 printf("\t Inv. twice eq. error variance:%lf\n\n",Inv_Twice_Eq_Err_Var);
 fflush(stdout);
 Print_Norm_Eq();
 return(0);
}
/******************************************************************************/
/*                    Get the autocorrelation of the error.
*******************************************************************************/
int Get_Autocorr()
{
 int cnt,inx,size;
 double re_mf[DATA_SIZE],im_mf[DATA_SIZE];
 double re_op[2*DATA_SIZE-ONE],im_op[2*DATA_SIZE-ONE];
 size=DATA_SIZE;
 Copy_Rev_Conjugate(Re_Err_Reg,Im_Err_Reg,re_mf,im_mf,size);
 Convolve(Re_Err_Reg,Im_Err_Reg,re_mf,im_mf,re_op,im_op,size,size);
 Eq_Err_Var=0.5*re_op[DATA_SIZE-ONE]/(double)(DATA_SIZE);
 return(0);
}
/******************************************************************************/
/*               Print the normalized equalizer coefficients.
*******************************************************************************/
int Print_Norm_Eq()
{
 int cnt;
 double energy,fac;
 energy=0.0;
 for(cnt=ZERO;cnt<EQ_SIZE;cnt++)
 {
  energy=energy+Re_Eq[cnt]*Re_Eq[cnt];
  energy=energy+Im_Eq[cnt]*Im_Eq[cnt];
 }
 fac=1.0/sqrt(energy);
 for(cnt=ZERO;cnt<EQ_SIZE;cnt++)
  fprintf(fp4,"%lf %lf\n",fac*Im_Eq[cnt],fac*Re_Eq[cnt]);
 return(0);
}
/******************************************************************************/
