/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teqdfsetype.h"
#include "teqdfseext.h"
/******************************************************************************/
/*                          Check the variables.
*******************************************************************************/
int Ck_Var()
{
 Ck_Tx_Constell_Size();
 Ck_Num_States();
 Ck_Num_Ch_States();
 Ck_Num_Rdu_Ch_States();
 return(0);
}
/******************************************************************************/
/*                Check the transmitted constellation size.
*******************************************************************************/
int Ck_Tx_Constell_Size()
{
 int cnt,pow;
 pow=1;
 for(cnt=ZERO;cnt<BITS_PER_SYM;cnt++)
  pow=pow*2;
 if(CONSTELL_SIZE != pow)
  Error_Mes(2);
 return(0);
}
/******************************************************************************/
/*                       Check the number of states.
*******************************************************************************/
int Ck_Num_States()
{
 int cnt,pow;
 pow=1;
 for(cnt=ZERO;cnt<MEM_SIZE;cnt++)
  pow=pow*2;
 if(NUM_STATES != pow)
  Error_Mes(3);
 return(0);
}
/******************************************************************************/
/*                     Check the number of channel states.
*******************************************************************************/
int Ck_Num_Ch_States()
{
 int cnt,pow;
 pow=1;
 for(cnt=ZERO;cnt<CHAN_MEM_SIZE;cnt++)
  pow=pow*NUM_INPUTS;
 if(pow != MOD_NUM_INPUTS)
  Error_Mes(10);
 pow=pow*NUM_STATES;
 if(NUM_CH_STATES != pow)
  Error_Mes(9);
 return(0);
}
/******************************************************************************/
/*                     Check the number of reduced states.
*******************************************************************************/
int Ck_Num_Rdu_Ch_States()
{
 if(RDU_CH_STATES != (MOD1_NUM_INPUTS*NUM_STATES))
  Error_Mes(12);
 return(0);
}
/******************************************************************************/
