/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teqex10type.h"
#include "teqex10ext.h"
/******************************************************************************/
/*         Compute the channel MAP decoder output mutual information.
*******************************************************************************/
int Compute_Output_Ch_MI()
{
 int bit;
 double mean,var,llim,ulim,step,x,y0,y1,numer,denom;
 mean=Ch_Mean;
 var=Ch_Var;
 llim= -mean-5.0*sqrt(var);
 ulim=  mean+5.0*sqrt(var);
 step=(ulim-llim)/(double)MAX_STEPS;
 Ch_Op_MI=0.0;
 for(bit=ZERO;bit<NUM_INPUTS;bit++)
 {
  for(x=llim;x<ulim;x=x+step)
  {
   y0=(x-mean*Bit_Map[bit])*(x-mean*Bit_Map[bit])/(2.0*var);
   y1=(x+mean*Bit_Map[bit])*(x+mean*Bit_Map[bit])/(2.0*var);
   numer=exp(-y0);
   denom=exp(-y0)+exp(-y1);
   Ch_Op_MI=Ch_Op_MI+numer*log(2.0*numer/denom);
  }
 }
 Ch_Op_MI=Ch_Op_MI*0.5*step/(sqrt(2.0*MY_PI*var)*log(2.0));
 return(0);
}
/******************************************************************************/
/*            Compute the CC MAP decoder output mutual information.
*******************************************************************************/
int Compute_Output_CC_MI()
{
 int bit;
 double mean,var,llim,ulim,step,x,y0,y1,numer,denom;
 mean=CC_Mean;
 var=CC_Var;
 llim= -mean-5.0*sqrt(var);
 ulim=  mean+5.0*sqrt(var);
 step=(ulim-llim)/(double)MAX_STEPS;
 CC_Op_MI=0.0;
 for(bit=ZERO;bit<NUM_INPUTS;bit++)
 {
  for(x=llim;x<ulim;x=x+step)
  {
   y0=(x-mean*Bit_Map[bit])*(x-mean*Bit_Map[bit])/(2.0*var);
   y1=(x+mean*Bit_Map[bit])*(x+mean*Bit_Map[bit])/(2.0*var);
   numer=exp(-y0);
   denom=exp(-y0)+exp(-y1);
   CC_Op_MI=CC_Op_MI+numer*log(2.0*numer/denom);
  }
 }
 CC_Op_MI=CC_Op_MI*0.5*step/(sqrt(2.0*MY_PI*var)*log(2.0));
 return(0);
}
/******************************************************************************/
