/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
extern FILE *fp1,*fp2,*fp3,*fp4,*fp5,*fp6,*fp7,*fp8;        /* File pointers. */
/******************************************************************************/
/*                                BIT VARIABLES.
*******************************************************************************/
extern int Frame_Cnt;                                         /* Frame count. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
extern int Enc_State;                                       /* Encoder state. */
extern int Enc_Op[CH_IV_SIZE];                                /* Encoder o/p. */
extern double P_Sym[CH_IV_SIZE];            /* Parity symbols at encoder o/p. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
extern double Bit_Map[CONSTELL_SIZE];                /* Map to constellation. */
/******************************************************************************/
/*                 VARIABLES RELATED TO CHANNEL INTERLEAVER.
*******************************************************************************/
extern int Ch_Iv_Map[CH_IV_SIZE];                     /* Interleaver mapping. */
extern int Ch_De_Iv_Map[CH_IV_SIZE];                /* Deinterleaver mapping. */
extern unsigned short Iv_Noise_Store[PN_SIZE];          /* Stores PNS status. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
extern unsigned short N1_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N2_Store[PN_SIZE];                /* Stores PNS status. */
extern double Snr;                                    /* SNR per uncoded bit. */
extern double Variance;                                    /* Noise variance. */
extern double Inv_Twice_Noise_Var;    /* Inverse of twice the noise variance. */
extern double N1_Val[NVALSIZE];                  /* Contains U & G rand. var. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
extern int Enc_P0[ENC_SIZE];                         /* Stores parity 0 taps. */
extern int Enc_P1[ENC_SIZE];                         /* Stores parity 1 taps. */
extern int Trel_NS[NUM_STATES][NUM_INPUTS];                    /* Next state. */
extern int Trel_PS[NUM_STATES][NUM_INPUTS];                    /* Prev state. */
extern int Trel_Ip[NUM_STATES];                    /* Stores input to states. */
extern int Trel_Op[NUM_STATES][NUM_INPUTS];                       /* Outputs. */
/******************************************************************************/
/*                VARIABLES RELATED TO THE CHANNEL TRELLIS.
*******************************************************************************/
extern int Ch_Trel_NS[NUM_CH_STATES][NUM_INPUTS];              /* Next state. */
extern int Ch_Trel_PS[NUM_CH_STATES][NUM_INPUTS];              /* Prev state. */
extern int Ch_Trel_Ip[NUM_CH_STATES][NUM_INPUTS];          /* Input to state. */
extern double Ch_Trel_Op[NUM_CH_STATES][NUM_INPUTS];              /* Outputs. */
/******************************************************************************/
/*                     VARIABLES RELATED TO THE CHANNEL.
*******************************************************************************/
extern int Chan_F_State;                       /* Final state of the channel. */
extern double Chan_Tap[CHAN_SIZE];                   /* Channel coefficients. */
extern double Chan_Op[CH_IV_SIZE];                         /* Channel output. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
extern double Alpha[FRAME_SIZE][NUM_STATES];                       /* Alphas. */
extern double Beta[FRAME_SIZE_P1][NUM_STATES];                      /* Betas. */
extern double Gamma_P0[FRAME_SIZE][NUM_INPUTS];        /* Extrinsic info: P0. */
extern double Gamma_P1[FRAME_SIZE][NUM_INPUTS];        /* Extrinsic info: P1. */
extern double Prob[FRAME_SIZE][NUM_INPUTS];            /* Data probabilities. */
/******************************************************************************/
/*                BCJR VARIABLES RELATED TO CHANNEL DECODER.
*******************************************************************************/
extern double Ch_Alpha[CH_IV_SIZE][NUM_CH_STATES];                  /* Alpha. */
extern double Ch_Beta[CH_IV_SIZE_P1][NUM_CH_STATES];                 /* Beta. */
extern double Ch_Gamma[CH_IV_SIZE][NUM_CH_STATES][NUM_INPUTS];      /* Gamma. */
extern double Ch_Prob[CH_IV_SIZE][NUM_INPUTS];              /* Probabilities. */
/******************************************************************************/
/*                LOG LIKELIHOOD RATIOS AND MUTUAL INFORMATION.
*******************************************************************************/
extern double LLR_Variance;                   /* Var. of noise added to LLRs. */
extern double Inv_Twice_LLR_Var;  /* Inverse of twice the LLR noise variance. */
extern double Ip_MI;                             /* Input mutual information. */
extern double Op_MI;                            /* Output mutual information. */
extern double Ch_Op_MI;               /* Mutual info. at ch. MAP decoder o/p. */
extern double CC_Op_MI;               /* Mutual info. at CC. MAP decoder o/p. */
extern double Ch_Mean;                    /* Mean LLR at ch. MAP decoder o/p. */
extern double CC_Mean;                    /* Mean LLR at CC. MAP decoder o/p. */
extern double Ch_Var;                                    /* Ch. LLR variance. */
extern double CC_Var;                                    /* CC. LLR variance. */
extern double Ch_LLR[NUM_INPUTS];                    /* LLRs for the channel. */
extern double CC_LLR[NUM_INPUTS];         /* LLRs for the convolutional code. */
/******************************************************************************/
/*                            HISTOGRAM PARAMETERS.
*******************************************************************************/
extern double Min_Ch_LLR;                                /* Min. channel LLR. */
extern double Max_Ch_LLR;                                /* Max. channel LLR. */
extern double Min_CC_LLR;                                     /* Min. CC LLR. */
extern double Max_CC_LLR;                                     /* Max. CC LLR. */
extern double Ch_Hist_Step;                   /* Channel histogram step size. */
extern double CC_Hist_Step;                        /* CC histogram step size. */
extern int Ch_Freq[HIST_SIZE];                     /* Channel histogram freq. */
extern int CC_Freq[HIST_SIZE];                          /* CC histogram freq. */
/******************************************************************************/
