/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teqex2type.h"
#include "teqex2ext.h"
/******************************************************************************/
/*                         Convert decimal to binary.
*******************************************************************************/
int Decimal_to_Binary(num,array,array_size)
int num,array[],array_size;
{
 int cnt;
 for(cnt=ZERO;cnt<array_size;cnt++)
  array[cnt]=ZERO;
 cnt=ZERO;
 while(num>ZERO)
 {
  if(cnt == array_size)
   Error_Mes(1);
  array[cnt]=num&1;
  num=num>>1;
  cnt++;
 }
 return(0);
}
/******************************************************************************/
/*                    Convert binary array to decimal.
*******************************************************************************/
int Binary_to_Decimal(array,size)
int array[],size;
{
 int cnt,pow,sum;
 sum=ZERO;
 pow=1;
 for(cnt=ZERO;cnt<size;cnt++)
 {
  sum=sum+pow*array[cnt];
  pow=pow<<1;
 }
 return(sum);
}
/******************************************************************************/
/*                      Normalize the alpha-beta values.
*******************************************************************************/
int Normalize_Alpha_Beta(time)
int time;
{
 int state;
 double suma,sumb;
 suma=sumb=0.0;
 for(state=ZERO;state<NUM_STATES;state++)
 {
  suma=suma+Alpha[time+ONE][state];
  sumb=sumb+Beta[FRAME_SIZE-ONE-time][state];
 }
 for(state=ZERO;state<NUM_STATES;state++)
 {
  Alpha[time+ONE][state]=Alpha[time+ONE][state]/suma;
  Beta[FRAME_SIZE-ONE-time][state]=Beta[FRAME_SIZE-ONE-time][state]/sumb;
 }
 return(0);
}
/******************************************************************************/
/*                  Normalize the channel alpha-beta values.
*******************************************************************************/
int Normalize_Ch_Alpha_Beta(time)
int time;
{
 int state,inx,bit;
 double suma,sumb;
 inx=Ch_De_Iv_Map[time];
 bit=Enc_Op[inx];
 suma=sumb=0.0;
 for(state=ZERO;state<NUM_CH_STATES;state++)
 {
  suma=suma+Ch_Alpha[time+ONE][state];
  sumb=sumb+Ch_Beta[CH_IV_SIZE-ONE-time][state];
 }
 for(state=ZERO;state<NUM_CH_STATES;state++)
 {
  Ch_Alpha[time+ONE][state]=Ch_Alpha[time+ONE][state]/suma;
  Ch_Beta[CH_IV_SIZE-ONE-time][state]=Ch_Beta[CH_IV_SIZE-ONE-time][state]/sumb;
 }
 return(0);
}
/******************************************************************************/
/*                Right shift the contents of the registers.
*******************************************************************************/
int Shift_Right(array,size)
int size;
double array[];
{
 int cnt;
 for(cnt=(size-ONE);cnt>ZERO;cnt--)
  array[cnt]=array[cnt-ONE];
 return(0);
}
/******************************************************************************/
/*  Convert uniform random variables to gaussian random variables. Refer to
 *  DSP by Proakis and Manolakis.
*******************************************************************************/
int My_Gauss(tvar,tnarry)
double tvar,tnarry[];
{
 double r,theta;
 r= -2.0*tvar*log(1.0-tnarry[URADIUS]);
 if(r < FRAC_ZERO)
  Error_Mes(4);
 r=sqrt(r);
 theta=2.0*MY_PI*tnarry[UTHETA];
 tnarry[GRAND_0]=r*cos(theta);
 tnarry[GRAND_1]=r*sin(theta);
 return(0);
}
/******************************************************************************/
/*                 Check for memory allocation failure.
*******************************************************************************/
int Ck_Calloc(tmp)
void *tmp;
{
 if(tmp==NULL)
  Error_Mes(5);
 return(0);
}
/******************************************************************************/
/*                             Error message.
*******************************************************************************/
int Error_Mes(num)
int num;
{
 fprintf(stdout,"\t Simulation error. Exiting with code %d.\n\n",num);
 exit(num);
 return(0);
}
/******************************************************************************/
