/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
FILE *fp1,*fp2,*fp3,*fp4,*fp5,*fp6,*fp7,*fp8;               /* File pointers. */
/******************************************************************************/
/*                                BIT VARIABLES.
*******************************************************************************/
int Frame_Cnt;                                                /* Frame count. */
/******************************************************************************/
/*                             ENCODER VARIABLES.
*******************************************************************************/
int Enc_State;                                              /* Encoder state. */
int Enc_Op[CH_IV_SIZE];                                       /* Encoder o/p. */
double P_Sym[CH_IV_SIZE];                   /* Parity symbols at encoder o/p. */
/******************************************************************************/
/*                       MAP TO CONSTELLATION VARIABLES.
*******************************************************************************/
double Bit_Map[CONSTELL_SIZE];                       /* Map to constellation. */
/******************************************************************************/
/*                 VARIABLES RELATED TO CHANNEL INTERLEAVER.
*******************************************************************************/
int Ch_Iv_Map[CH_IV_SIZE];                            /* Interleaver mapping. */
int Ch_De_Iv_Map[CH_IV_SIZE];                       /* Deinterleaver mapping. */
unsigned short Iv_Noise_Store[PN_SIZE];                 /* Stores PNS status. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
unsigned short N1_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N2_Store[PN_SIZE];                       /* Stores PNS status. */
double Snr;                                           /* SNR per uncoded bit. */
double Variance;                                           /* Noise variance. */
double Inv_Twice_Noise_Var;           /* Inverse of twice the noise variance. */
double N1_Val[NVALSIZE];                         /* Contains U & G rand. var. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
int Enc_N[ENC_SIZE];                           /* Stores encoder numer. taps. */
int Enc_D[ENC_SIZE];                           /* Stores encoder denom. taps. */
int Trel_NS[NUM_STATES][NUM_INPUTS];                           /* Next state. */
int Trel_PS[NUM_STATES][NUM_INPUTS];                           /* Prev state. */
int Trel_Op[NUM_STATES][NUM_INPUTS];                              /* Outputs. */
/******************************************************************************/
/*                VARIABLES RELATED TO THE CHANNEL TRELLIS.
*******************************************************************************/
int Ch_Trel_NS[NUM_CH_STATES][NUM_INPUTS];                     /* Next state. */
int Ch_Trel_PS[NUM_CH_STATES][NUM_INPUTS];                     /* Prev state. */
int Ch_Trel_Ip[NUM_CH_STATES][NUM_INPUTS];                 /* Input to state. */
double Re_Ch_Trel_Op[NUM_CH_STATES][NUM_INPUTS];                  /* Re. o/p. */
double Im_Ch_Trel_Op[NUM_CH_STATES][NUM_INPUTS];                  /* Im. o/p. */
/******************************************************************************/
/*                     VARIABLES RELATED TO THE CHANNEL.
*******************************************************************************/
int Chan_F_State;                              /* Final state of the channel. */
double Chan_Tap[CHAN_SIZE];                          /* Channel coefficients. */
double Re_Chan_Op[CH_IV_SIZE];                         /* Re. channel output. */
double Im_Chan_Op[CH_IV_SIZE];                         /* Im. channel output. */
/******************************************************************************/
/*                            BCJR VARIABLES.
*******************************************************************************/
double Alpha[FRAME_SIZE][NUM_STATES];                              /* Alphas. */
double Beta[FRAME_SIZE_P1][NUM_STATES];                             /* Betas. */
double Gamma_I[FRAME_SIZE][NUM_INPUTS];              /* Intrinsic info: data. */
double Gamma_P[FRAME_SIZE][NUM_INPUTS];            /* Extrinsic info: parity. */
double Prob[FRAME_SIZE][NUM_INPUTS];                   /* Data probabilities. */
/******************************************************************************/
/*                BCJR VARIABLES RELATED TO CHANNEL DECODER.
*******************************************************************************/
double Ch_Alpha[CH_IV_SIZE][NUM_CH_STATES];                         /* Alpha. */
double Ch_Beta[CH_IV_SIZE_P1][NUM_CH_STATES];                        /* Beta. */
double Ch_Gamma[CH_IV_SIZE][NUM_CH_STATES][NUM_INPUTS];             /* Gamma. */
double Ch_Prob[CH_IV_SIZE][NUM_INPUTS];                     /* Probabilities. */
/******************************************************************************/
/*                LOG LIKELIHOOD RATIOS AND MUTUAL INFORMATION.
*******************************************************************************/
double LLR_Variance;                          /* Var. of noise added to LLRs. */
double Inv_Twice_LLR_Var;         /* Inverse of twice the LLR noise variance. */
double Ip_MI;                                    /* Input mutual information. */
double Op_MI;                                   /* Output mutual information. */
double Ch_Op_MI;                      /* Mutual info. at ch. MAP decoder o/p. */
double CC_Op_MI;                      /* Mutual info. at CC. MAP decoder o/p. */
double Ch_Mean;                           /* Mean LLR at ch. MAP decoder o/p. */
double CC_Mean;                           /* Mean LLR at CC. MAP decoder o/p. */
double Ch_Var;                                           /* Ch. LLR variance. */
double CC_Var;                                           /* CC. LLR variance. */
double Ch_LLR[NUM_INPUTS];                           /* LLRs for the channel. */
double CC_LLR[NUM_INPUTS];                /* LLRs for the convolutional code. */
/******************************************************************************/
/*                            HISTOGRAM PARAMETERS.
*******************************************************************************/
double Min_Ch_LLR;                                       /* Min. channel LLR. */
double Max_Ch_LLR;                                       /* Max. channel LLR. */
double Min_CC_LLR;                                            /* Min. CC LLR. */
double Max_CC_LLR;                                            /* Max. CC LLR. */
double Ch_Hist_Step;                          /* Channel histogram step size. */
double CC_Hist_Step;                               /* CC histogram step size. */
int Ch_Freq[HIST_SIZE];                            /* Channel histogram freq. */
int CC_Freq[HIST_SIZE];                                 /* CC histogram freq. */
/******************************************************************************/
