/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teqex6type.h"
#include "teqex6ext.h"
/******************************************************************************/
int Pre_Processor()
{
 Ck_Var();
 Open_Files();
 Sim_Init();
 Get_BPSK_Map();
 Get_Channel_Iv_Map();
 Get_Enc_Taps();
 Get_Trellis();
 Get_Channel_Taps();
 Normalize_Channel_Taps();
 Get_Channel_Trellis();
 return(0);
}
/******************************************************************************/
/*                           Open files for reading.
*******************************************************************************/
int Open_Files()
{
 fp1=fopen("teqex6data/chan.dat","r");
 fp2=fopen("teqex6data/normchan.dat","w");
 fp3=fopen("teqex6data/exch.dat","w");
 fp4=fopen("teqex6data/excc.dat","w");
 fp5=fopen("teqex6data/chhist.dat","w");
 fp6=fopen("teqex6data/cchist.dat","w");
 fp7=fopen("teqex6data/chgauss.dat","w");
 fp8=fopen("teqex6data/ccgauss.dat","w");
 if(fp1 == NULL)
  Error_Mes(7);
 if(fp2 == NULL)
  Error_Mes(8);
 return(0);
}
/******************************************************************************/
/*                           Get encoder 1 taps.
*******************************************************************************/
int Get_Enc_Taps()
{
 Get_Enc_Numer_Taps();
 Get_Enc_Denom_Taps();
 return(0);
}
/******************************************************************************/
/*       Get encoder 1 numerator taps corresponding to 1+D^2.
*******************************************************************************/
int Get_Enc_Numer_Taps()
{
 Enc_N[0]=1;
 Enc_N[1]=0;
 Enc_N[2]=1;
 return(0);
}
/******************************************************************************/
/*         Get encoder 1 denominator taps corresponding to 1+D+D^2.
*******************************************************************************/
int Get_Enc_Denom_Taps()
{
 Enc_D[0]=1;
 Enc_D[1]=1;
 Enc_D[2]=1;
 return(0);
}
/******************************************************************************/
/*                             Get the channel taps.
*******************************************************************************/
int Get_Channel_Taps()
{
 int cnt;
 double tap;
 cnt=ZERO;
 while(fscanf(fp1,"%lf",&tap) != EOF)
 {
  if(cnt == CHAN_SIZE)
   Error_Mes(14);
  Chan_Tap[cnt]=tap;
  cnt++;
 }
 if(cnt != CHAN_SIZE)
  Error_Mes(15);
 return(0);
}
/******************************************************************************/
/*                       Normalize the channel taps.
*******************************************************************************/
int Normalize_Channel_Taps()
{
 int cnt;
 double energy;
 energy=0.0;
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
  energy=energy+Chan_Tap[cnt]*Chan_Tap[cnt];
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
 {
  Chan_Tap[cnt]=Chan_Tap[cnt]/sqrt(energy);
  fprintf(fp2,"%lf %lf\n",(double)cnt,Chan_Tap[cnt]);
 }
 return(0);
}
/******************************************************************************/
