/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teqex8type.h"
#include "teqex8ext.h"
/******************************************************************************/
int Get_Channel_Iv_Map()
{
 int ck_iv_inx[CH_IV_SIZE];
 double iv_noise_val[CH_IV_SIZE];
 Get_Ch_Uniform_Noise(iv_noise_val);
 Init_Ch_Ck_Iv_Inx(ck_iv_inx);
 Get_Ch_Iv_Elements(iv_noise_val,ck_iv_inx);
 Print_Ch_Iv_Map();
 return(0);
}
/******************************************************************************/
/*                   Get uniformly distributed noise.
*******************************************************************************/
int Get_Ch_Uniform_Noise(iv_noise_val)
double iv_noise_val[];
{
 int cnt;
 double erand48();
 for(cnt=ZERO;cnt<CH_IV_SIZE;cnt++)
  iv_noise_val[cnt]=erand48(Iv_Noise_Store);
 return(0);
}
/******************************************************************************/
/*                 Initialize the interleaver check vector.
*******************************************************************************/
int Init_Ch_Ck_Iv_Inx(ck_iv_inx)
int ck_iv_inx[];
{
 int cnt;
 for(cnt=ZERO;cnt<CH_IV_SIZE;cnt++)
  ck_iv_inx[cnt]=ZERO;
 return(0);
}
/******************************************************************************/
/*                        Get the interleaver map.
*******************************************************************************/
int Get_Ch_Iv_Elements(iv_noise_val,ck_iv_inx)
int ck_iv_inx[];
double iv_noise_val[];
{
 int cnt,max_inx,iv_inx;
 double max;
 for(iv_inx=ZERO;iv_inx<CH_IV_SIZE;iv_inx++)
 {
  max=MIN_MAG;
  for(cnt=ZERO;cnt<CH_IV_SIZE;cnt++)
  {
   if((ck_iv_inx[cnt] == ZERO) && (iv_noise_val[cnt] > max))
   {
    max=iv_noise_val[cnt];
    max_inx=cnt;
   }
  }
  ck_iv_inx[max_inx]=ONE;                    /* Dont check max_inx next time. */
  Ch_Iv_Map[iv_inx]=max_inx;                              /* Interleaver map. */
  Ch_De_Iv_Map[max_inx]=iv_inx;                         /* Deinterleaver map. */
 }
 return(0);
}
/******************************************************************************/
/*                       Print the interleaver map.
*******************************************************************************/
int Print_Ch_Iv_Map()
{
 int cnt;
 printf("\t Channel interleaver map.\n\n");
 for(cnt=ZERO;cnt<CH_IV_SIZE;cnt++)
 {
  printf("\t\t Ch. Iv. map Index:%5d Map:%5d\n",cnt,Ch_Iv_Map[cnt]);
  printf("\t\t Ch. Dv. map Index:%5d Map:%5d\n",cnt,Ch_De_Iv_Map[cnt]);
 }
 printf("\n");
 fflush(stdout);
 return(0);
}
/******************************************************************************/
