/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
#include "teqex8type.h"
#include "teqex8ext.h"
/******************************************************************************/
int Pre_Processor()
{
 Ck_Var();
 Open_Files();
 Sim_Init();
 Get_BPSK_Map();
 Get_Channel_Iv_Map();
 Get_Enc_Taps();
 Get_Trellis();
 Get_Channel_Taps();
 Normalize_Channel_Taps();
 Get_Super_Trellis();
 return(0);
}
/******************************************************************************/
/*                           Open files for reading.
*******************************************************************************/
int Open_Files()
{
 fp1=fopen("teqex8data/chan.dat","r");
 fp2=fopen("teqex8data/normchan.dat","w");
 fp3=fopen("teqex8data/exch.dat","w");
 fp4=fopen("teqex8data/excc.dat","w");
 fp5=fopen("teqex8data/chhist.dat","w");
 fp6=fopen("teqex8data/cchist.dat","w");
 fp7=fopen("teqex8data/chgauss.dat","w");
 fp8=fopen("teqex8data/ccgauss.dat","w");
 fp9=fopen("teqex8data/eqerr.dat","w");
 fp10=fopen("teqex8data/normeq.dat","w");
 fp11=fopen("teqex8data/normfb.dat","w");
 if(fp1 == NULL)
  Error_Mes(7);
 if(fp2 == NULL)
  Error_Mes(8);
 return(0);
}
/******************************************************************************/
/*                           Get encoder 1 taps.
*******************************************************************************/
int Get_Enc_Taps()
{
 Get_Enc_Numer_Taps();
 Get_Enc_Denom_Taps();
 return(0);
}
/******************************************************************************/
/*       Get encoder 1 numerator taps corresponding to 1+D^2.
*******************************************************************************/
int Get_Enc_Numer_Taps()
{
 Enc_N[0]=1;
 Enc_N[1]=0;
 Enc_N[2]=1;
 return(0);
}
/******************************************************************************/
/*         Get encoder 1 denominator taps corresponding to 1+D+D^2.
*******************************************************************************/
int Get_Enc_Denom_Taps()
{
 Enc_D[0]=1;
 Enc_D[1]=1;
 Enc_D[2]=1;
 return(0);
}
/******************************************************************************/
/*                             Get the channel taps.
*******************************************************************************/
int Get_Channel_Taps()
{
 int cnt;
 double retap,imtap;
 cnt=ZERO;
 while(fscanf(fp1,"%lf %lf",&imtap,&retap) != EOF)
 {
  if(cnt == CHAN_SIZE)
   Error_Mes(11);
  Re_Ch[cnt]=retap;
  Im_Ch[cnt]=imtap;
  cnt++;
 }
 if(cnt != CHAN_SIZE)
  Error_Mes(10);
 return(0);
}
/******************************************************************************/
/*                       Normalize the channel taps.
*******************************************************************************/
int Normalize_Channel_Taps()
{
 int cnt;
 double energy;
 energy=0.0;
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
  energy=energy+Re_Ch[cnt]*Re_Ch[cnt]+Im_Ch[cnt]*Im_Ch[cnt];
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
 {
  Re_Ch[cnt]=Re_Ch[cnt]/sqrt(energy);
  Im_Ch[cnt]=Im_Ch[cnt]/sqrt(energy);
  fprintf(fp2,"%lf %lf\n",Im_Ch[cnt],Re_Ch[cnt]);
 }
}
/******************************************************************************/
