# Plot of the bit error rates for channel type 1 with 4 iterations.
##set term postscript eps color 22
set term postscript eps color
set key box
set grid xtics ytics mytics lw 0.5 lw 0.5
set format y "%1.0e"
set output "c1iter4.eps"
set logscale y
set xlabel "SNR per bit (dB)"
set ylabel "Bit error rate"
plot "../teq2/teq2data/teq2preiter4.dat"\
      t "Classical TEQ + precoding"\
      w lp lt -1 lw 1 pt 1,\
     "../teq2/teq2data/teq2nopreiter4.dat"\
      t "Classical TEQ"\
      w lp lt -1 lw 1 pt 2,\
     "../teq6/teq6data/teq6iter4.dat"\
      t "STMAP receiver"\
      w lp lt -1 lw 1 pt 3,\
     "../teq7/teq7data/teq7c1iter4.dat"\
      t "PDFE-STMAP receiver"\
      w lp lt -1 lw 1 pt 4,\
     "../teq8/teq8data/teq8c1iter4.dat"\
      t "CDFE-STMAP receiver"\
      w lp lt -1 lw 1 pt 5,\
     "../teq2/teq2data/noisi.dat"\
      t "Outer code in AWGN"\
      w l lt -1 lw 1,\
     "../teq6/teq6data/sctc.dat"\
      t "SCTC in AWGN"\
      w lp lt -1 lw 1 pt 6
