# Plot of the bit error rates for channel type 2 with 10 iterations.
##set term postscript eps color 22
set term postscript eps
set key bottom outside Left reverse box
set grid xtics ytics mytics lw 0.5 lw 0.5
set format y "%1.0e"
set output "c2iter10.eps"
set logscale y
set xlabel "SNR per bit (dB)"
set ylabel "Bit error rate"
plot "../teq2/teq2data/teq2prec2iter10.dat"\
      t "TEQ + precode, 16-states"\
      w lp lt -1 pt 1 ps 1,\
     "../teq2/teq2data/teq2noprec2iter10.dat"\
      t "Classical TEQ, 16-states"\
      w lp lt -1 pt 2 ps 1,\
     "../teq8/teq8data/teq8c2ideqiter10fb1.dat"\
      t "PDFE-STMAP, 8-states"\
      w lp lt -1 pt 3 ps 1,\
     "../teq8/teq8data/teq8c2ideqiter10fb2.dat"\
      t "PDFE-STMAP, 16-states"\
      w lp lt -1 pt 4 ps 1,\
     "../teq6/teq6data/teq6c2iter10.dat"\
      t "STMAP 64-states"\
      w lp lt -1 pt 5 ps 1,\
     "../teqdfse/teqdfsedata/teqdfsec2iter10fb2.dat"\
      t "RS-STMAP, 16-states"\
      w lp lt -1 pt 6 ps 1,\
     "../teq2/teq2data/noisi.dat"\
      t "Outer code in AWGN"\
      w l lt -1,\
     "../teq6/teq6data/sctc.dat"\
      t "SCTC in AWGN"\
      w lp lt -1 pt 7 ps 1
